(function() {
	/**
	 * @class B.system.CentralManagement.CentralMgr
	 * @extends SFX.mgr.GridMgr longtao 2015.04.21 集中管理中心控制器gridmgr
	 */
	var validator = new SFX.validations.LocalUserName();
	var UserCombox = Ext.extend(Ext.form.ComboBox,{
		editable : false,
		triggerAction : 'all',
		forceSelection : true,
		mode : 'local',
		width:100,
		valueField : 'id',
		displayField : 'text',
		initComponent:function(){
			this.store = new Ext.data.ArrayStore({
				fields : ['id', 'text'],
				data:this.storeData
			});
			UserCombox.superclass.initComponent.apply(this,arguments);
		}
	});
	var FilterForm = Ext.extend(SF.form.Form, {
		defaults: {
			anchor: "100%"
		},
		labelWidth: 90,
		initComponent: function() {
			this.initFields();
			FilterForm.superclass.initComponent.call(this);
		},
		initFields: function() {
			var me=this;
			this.items = [
				{
					xtype : "nametextfield",
					name : "name",
					allowBlank:true,
					maxLength : 64,//证书最长支持64个，超过会报错。
					validator : function (v) {
						return validator.verify(this.formatValue(v));
					},
					fieldLabel : _('分支名')
				},
				new B.system.CentralManagement.BranchGroupCombo({
					name : 'path',
					branchObj:this.branchObj,
					fieldLabel : _('所属组')
				}),
				new UserCombox({
					name:"status",
					fieldLabel:_("状态"),
					storeData:[
						[-2,_('所有')],
						[1,_('在线')],
						[0,_('离线')],
						[-1,"-"]

					]
				}),
				new UserCombox({
					name:"mode",
					fieldLabel:_("工作模式"),
					storeData:[
						[-1,_("所有")],
						[1,_('监控模式')],
						[2,_('管理模式')],
						[4,_('管理模式（集中认证）')],
						[5,_('管理模式（分布式认证）')],
						[3,_('维护模式')]
					]
				}),				
				new UserCombox({
					name:"unactive",
					fieldLabel:_("未激活接入点"),
					storeData:[
						[-1,_("所有")],
						[1,_("存在")],
						[0,_('不存在')]
					]
				}),
				new UserCombox({
					name:"offline",
					fieldLabel:_("离线接入点"),
					storeData:[
						[-1,_("所有")],
						[1,_("存在")],
						[0,_('不存在')]
					]
				}),
				{
					xtype : "container",
					layout : "column",
					fieldLabel : _('最近更新时间'),
					items : [
						{
							xtype : "box",
							style : "padding:5px 5px 5px 0px",
							html : _("从")
						},
						this.start = new Ext.form.DateField({
							//defaultValue : sdate,
							fieldLabel : _("开始时间"),
							editable : false,
							name : "beg",
							columnWidth : .49
						}),
						{
							xtype : "box",
							style : "padding:5px 5px",
							html : _("至")
						},
						this.end = new Ext.form.DateField({
							columnWidth : .49,
							//defaultValue : sdate.add(Date.DAY,1),
							editable : false,
							fieldLabel : _("结束时间"),
							name : "end"
						})
					]
				}
			];
		}

	});
	var Mgr = Ext.extend(SFX.mgr.GridMgr, {
		sort : "status",
		direction : "DESC",
		limit : 25,
		idProperty : "id",
		group_url:"/index.php/monitor_branch_area",
		exportFn:function(){
			var me = this;
			this.ajaxid = SF.Ajax.jsonRequest({
				url: me.url,
				waitMsg : _('正在加载数据，请稍候……'),
				params: {
					opr: "export"
				},
				success : function(json){
					SF.invoke(
						'openhtml',
						 me.url, { 
							opr : "export" 
						}
					); 
				},
				failure : function(json){
					SF.alert(json &&json.msg||_("加载数据失败"));
				}
			});
		},
		destroy : function(){
			if(this.netConfigWin){
				this.netConfigWin.destroy();
			}
			if(this.ajaxid){
				SF.Ajax.abort(this.ajaxid);
				delete this.ajaxid;
			}
			Mgr.superclass.destroy.apply(this,arguments);
		},
		actions : {
			"sss" : {
				fn:function(act,mgr){	
					var id = act.rs[0].data.id;
					mgr.changeParam = function(conn,obj){
						if(obj.jsonData){
							obj.jsonData.zj_branch_id = id;
						}																		
					}
					Ext.Ajax.on("beforerequest",mgr.changeParam);					
					if(!mgr.netConfigWin){
						mgr.netConfigWin = new B.system.CentralManagement.NetConfigWindow({});						
						mgr.netConfigWin.on(
							"hide",
							function(){
								Ext.Ajax.un("beforerequest",mgr.changeParam);
							}
						);
					}
					if(!mgr.centerAuthNetConfigWin){
						mgr.centerAuthNetConfigWin = new B.system.CentralManagement.NetConfigWindow({
							center_auth:true
						});						
						mgr.centerAuthNetConfigWin.on(
							"hide",
							function(){
								Ext.Ajax.un("beforerequest",mgr.changeParam);
							}
						);
					}
					if(act.rs[0].data.mode==='centerauth'){
						SF.center_auth_config=true;//在中心端给网点配置的页面，有线认证里面的在当前控制器上做Portal认证的选项要隐藏，只能选择第三方认证（JS）
						mgr.centerAuthNetConfigWin.show();
						SF.is_mgmt=false;
						mgr.centerAuthNetConfigWin.setTitle(_("分支名称：")+act.rs[0].data.name);
					}else{
						if(act.rs[0].data.mode==='mgmt'){
							SF.is_mgmt=true;
						}else{
							SF.is_mgmt=false;
						}
						SF.center_auth_config=false;
						mgr.netConfigWin.show();
						mgr.netConfigWin.setTitle(_("分支名称：")+act.rs[0].data.name);
					}
				}			
			},
			"loadData" : {
				type : "request",
				getParams : function(act, mgr){
					var params = {
						opr : "list",
						start : mgr.start,
						limit : mgr.limit
					};
					
					if(mgr.filter){
						params.filter = mgr.filter;
					}else{
						if(mgr.selectNode){
							params.filter ={id:mgr.selectNode.data.id};
						}
					}
					if(mgr.search){
						params.search = mgr.search;
					}
					act.grid && act.grid.setFilterKey && act.grid.setFilterKey(mgr.search);
					if(mgr.sort){
						params.sort = mgr.sort;
						params.direction = mgr.direction || "ASC";
					}
					return params;
				},
				getBaseOptions : function(act, mgr){
					var grid = mgr.grid;
					var auto = act.isAutoRefresh;
					var paging = act.isPaging;
					var noMsg = auto || paging || act.isWaitMsg === false;
					
					if(!Ext.isEmpty(grid.store) && !grid.store.datachanged) //td32775 datachange被空对象引用
					{
						noMsg = true;
						grid.applyLoadingText();
					}
					
					return {
						url : mgr.url,
//						waitMsgBuffer : true,
						waitMsg : noMsg ? false : _("正在更新表格数据，请稍候……")
					};
				},
				getOptions : function(act, mgr){
					var params = this.getParams(act, mgr);
					var options = this.getBaseOptions(act, mgr);
					options.params = params;
					return options;
				},
				success : "loadData.update",
				failure : "loadData.failure"
			},
			"delete" : {
				type:"edit",
				getForm:function(act,mgr){
					return mgr.getSingleton("deleteform");		
				},				
				confirmAction:"delete.request"
			},
			"delete.request" : {
				type : "request",
				getOptions : function(act, mgr){
					var sels = act.grid.getSelections(), i = sels.length, rs = [],data={};
					while (i > 0){
						rs.push(sels[i-1].json);
						i--;
					}
					data.data = rs;
					if(mgr.grid.selectAll){
						data.selectall = true;	
						data.filter = mgr.filter;
					}
					mgr.getSingleton("deleteform").hide();
					return {
						url : mgr.url,
						waitMsg : _("正在删除数据，请稍候……"),
						jsonData : {
							opr : "delete",
							data : data.data,
							filter : data.filter,
							selectall : data.selectall
						}
					};
				}, 
				success : "delete.request.success",
				failure : "std.showerr"
			},
			"delete.ifcited" : {
				fn : function (act, mgr) {
					mgr.grid.selectAll = false;//删除后取消全选状态
					mgr.selectAll= false;
					SFX.util.CitedWarnTip.show(act.lastResult.jsonData);
					return true;
				},
				complete : "std.showmsg"
			},
			"loadData.update" : {
				fn : function(act, mgr){
					var jsonData = act.lastResult.jsonData,
						data = jsonData.data || [],
						count = data.length,
						selectAll = mgr.grid.selectAll = mgr.selectAll;
					if(!act.isPaging){
						mgr.selectAll = mgr.grid.selectAll =  false;
					}
					
					if(mgr.sort){
						mgr.grid.setSortState({
							field : mgr.sort,
							direction : mgr.direction
						});
					}
					mgr.grid.setJsonValue(data);
					if(mgr.grid.checkStopRefresh==true){ //如果用户点击全选框暂停了自动刷新，这里要重启
						mgr.grid.topToolbar.getComponent("refresh").startAutoRefresh();
					}
					if(mgr.getPageToolbar()){
						mgr.getPageToolbar().setPageData({
							cursor : mgr.start,
							pageSize : mgr.limit,
							count : count,
							totalCount : jsonData.total
						});
					}
					if(mgr.quickSearchField){
						mgr.quickSearchField.setSearchValue(mgr.search);
					}
					if(selectAll){
						var totalcount = mgr.getPageToolbar().totalCount;
						mgr.selectAll = mgr.grid.selectAll =true;
						mgr.grid.selModel.locked = false;
						mgr.grid.getSelectionModel().selectAll();
						mgr.grid.updateSummary(totalcount,"selectAll");
					}else{
						mgr.selectAll = mgr.grid.selectAll =false;
						mgr.grid.getSelectionModel().clearSelections();
						mgr.grid.updateSummary(jsonData.total,act.lastAction.actionId);
					}
					return true;
				}
			},
			"loadData.failure" : { //grid加载失败不提示
				//ref : "std.showerr",
				complete : "loadData.reset"
			},
			"import" : {
				fn : function (act, mgr) {
					var win = mgr.createImportForm();
					win.open({
						confirm : function(form,config) {
							var fileField = form.findField('cfgfile');
							if(fileField && !fileField.getValue()) {
								SF.showErr(_("请选择一个文件上传(*.CSV)"));
								return false;
							}
							fileField && fileField.startUpload();
							return false;
						}
					});
				}
			},
			"export" : {
				fn : function (act, mgr) {
					mgr.exportFn();
				} 
			},
			"addnet" : {// 如果为add 会与 SFX.mgr.GridMgr中的add冲突，两个add都执行
				forward : function(act, mgr) {
					act.isEdit = false;					
					return "net.edit";
				}
			},
			"net.edit" : { // 添加,编辑分支
				type : "edit",
				getForm : function(act, mgr) {
					return mgr.getSingleton("netform");
                },
				getOptions : function(act, mgr) {
					var value = act.lastResult.jsonData&&act.lastResult.jsonData.data || {};
					var path  = mgr.selectNode&&mgr.selectNode.store?{id:mgr.selectNode.data.id,text:mgr.selectNode.getPath("text")} :{}
					if(!act.isEdit){					
						value.path = path;
					}
					return {
						title :act.isEdit ?  _("编辑分支"):_("新增分支"),
						//disables:act.isEdit ? {"name":true,"account":true}:{},
						value :value
					};
				},
				confirmAction : "net.edit.submit"
			},
			"net.edit.submit" : {
				type : "submit",
				getOptions : function(act, mgr){
					return {
						url : mgr.url,
						waitMsg : _("正在提交数据，请稍候……"),
						params : {
							opr : act.isEdit ?"modify":"create"
						}
					};
				},
				success : "net.edit.success",
				failure : "std.showerr"
			},
			"net.edit.success" : {
				forward : function(act, mgr){
					if(act.lastResult.msg){
						SF.showMsg(act.lastResult.msg);
					}
					return "loadData";
				}
			},
			"changeRole" : { // 切换控制器角色
				type : "edit",
				getForm : function(act, mgr) {
					return mgr.getSingleton("roleform");
				},
				getOptions : function(act, mgr) {
					return {
						value : {},
						disables : false,
						title : _("选择控制器角色")
					};
				},
				confirmAction : "changeRole.submit"
			},
			"changeRole.submit" : {
				type : "submit",
				getOptions : function(act, mgr){
					return {
						url : mgr.url,
						waitMsg : _("正在提交数据，请稍候……"),
						params : {
							opr : "switch_wac_role"
						}
					};
				},
				success : "loadData",
				failure : "std.showerr"
			},
			"loadApgrpConfig" :{
				type:"request",
				getOptions : function(act, mgr){
					return {
						waitMsg : _("正在加载编辑数据，请稍候……"),
						url : mgr.url,
						jsonData : {
							opr : "load_apgrp_config",
							data : [{"id":act.rs[0].data.id,"account":act.rs[0].data.account}]
						}
					};
				},
				success : "std.showmsg",
				failure : "std.showerr"				
			},
			"p_syncConfig" : {
				forward : function(act, mgr){
					var sels = act.grid.getSelections(), i = sels.length, data = [];
					while (i > 0){
						data.push({id:sels[i-1].json.id,account:sels[i-1].json.account,name:sels[i-1].json.name});
						i--;
					}
					act.syncData = {
						data:data						
					};
					if(mgr.grid.selectAll){
						act.syncData.selectall = true;
						act.syncData.filter = mgr.filter;
					}
					return "syncConfig.request";										
				}
			},
			"syncConfig" : {
				forward : function(act, mgr){
					act.singleSync = true; //单个分支同步
					act.syncData = {
						data:[{"id":act.branchData.id,"account":act.branchData.account,"name":act.branchData.name}]			
					};
					return "syncConfig.request";										
				}
			},
			"syncConfig.request" :{
				type:"request",
				getOptions : function(act, mgr){					
					return {
						waitMsg : _("正在加载编辑数据，请稍候……"),
						url : mgr.url,
						jsonData : Ext.apply({
							opr : "load_sync_config"							
						},act.syncData)
					};
				},
				success : "syncConfig.success",
				failure : "std.showerr"				
			},
			"syncConfig.success" :{
				fn : function(act, mgr){
					SF.showMsg(_('请求数据成功。'));
                    if(act.singleSync) {
                        SF.showInfo(_('中心控制器已触发同步数据到分支，此过程需耗时1-3分钟，同步成功将在系统日志中返回相应信息。'));
                    }else{
                        SF.showInfo(_('中心控制器已触发同步数据到在线的管理模式分支，此过程需耗时1-3分钟，同步成功将在系统日志中返回相应信息。'));
                    }
				}
			},
			"modify":{
				type:"request",
				getOptions:function(act,mgr){
					act.isEdit = true;
					return {
						url:mgr.url,
						waitMsg : true,
						params : {
							opr : "listDetail",
							data : act.branchData							
						}
					}
				},
				success : "net.edit",
				failure : "std.showerr"			
			},
			"synLog":{
				fn:function(act,mgr){
                    if(act.rs){
                        mgr.grid.showSynLogTip(act.event.xy, act.rs[0].data);
                    }
					//mgr.grid.showSynLogTip(act.event.target,{"id":act.rs[0].data.id,"account":act.rs[0].data.account});
				}
				/**
				type:"edit",
				getForm:function(act,mgr){
					
					//alert(act.rs[0].get(mgr.idProperty));
				}**/				
			},
			"setReleasePwd":{
				type:"request",
				getOptions:function(act,mgr){
					return {
						url:mgr.url,
						params:{
							opr:"get_global_release_pwd"
						}						
					}
				},
				success : "setReleasePwd.edit",
				failure : "std.showerr"	
			},
			"setReleasePwd.edit":{
				type:"edit",
				getForm:function(act,mgr){
					mgr.getSingleton("releasepwdform").find('name','pwd')[0].setJsonValue(act.lastResult.jsonData.data.pwd);
					mgr.getSingleton("releasepwdform").find('name','pwd_confirm')[0].setJsonValue(act.lastResult.jsonData.data.pwd_confirm);
					return mgr.getSingleton("releasepwdform");
				}
			},
			"opt_menu":{
				fn:function(act,mgr){
					var menu = new Ext.menu.Menu({
						items:[
							{
								text:_("登录分支"),
								menu:{
									items:[
										{
											text:_("主机"),
											handler:function(){		
												mgr.ssoAction("master",act.rs[0].data);																							
											}									
										},{
											text:_("备机"),
											handler:function(){
												mgr.ssoAction("slave",act.rs[0].data);													
											}									
										}
									]	
								}
							},{
								text:_("切换模式"),
								menu:{
									items:[
                                        {
                                            text:_("管理模式"),
                                            menu:{
                                                items:[
                                                    {
                                                        text:_("分布式认证"),
                                                        handler:function(){
                                                            mgr.changeMode("mgmt",act.rs[0].data,0);
                                                        }
                                                    },
                                                    {
                                                        text:_("集中认证"),
                                                        handler:function(){
                                                            mgr.changeMode("mgmt",act.rs[0].data,1);
                                                        }
                                                    }
                                                ]
                                            }
                                            //	handler:function(){
                                            //		mgr.changeMode("mgmt",act.rs[0].data);
                                            //		}
                                        },{
											text:_("监控模式"),
											handler:function(){
												mgr.changeMode("monitor",act.rs[0].data);
											}
										},{
											text:_("维护模式"),
											handler:function(){
												mgr.changeMode("mainten",act.rs[0].data);
											}
										}
									]
								}	
							},{
								text:_("立即同步"),
								handler:function(){
									if(act.rs[0].data.status === -1){
										SF.showInfo(_("该分支未使用，无法同步配置。"));
										return;
									}
									if(act.rs[0].data.status === 0){
										SF.showInfo(_("该分支不在线，无法同步配置。"));
										return;
									}
									if(act.rs[0].data.mode === "mainten"){//mainten
										SF.showInfo(_("该分支为维护模式，无法同步配置。"));
										return;
									}
									if(act.rs[0].data.mode === "monitor"){//mainten
										SF.showInfo(_("该分支为监控模式，无法同步配置。"));
										return;
									}
									mgr.preProcessAct("syncConfig",{"branchData":{"account":act.rs[0].data.account,"id":act.rs[0].data.id}});	
								}
							},{
								text:_("编辑分支"),
								handler:function(){
									mgr.preProcessAct("modify",{"branchData":{"account":act.rs[0].data.account,"id":act.rs[0].data.id}});
								}
							}
						]	
					});					
					menu.showAt(act.event.xy);				
				}				
			},
			"p_mgmt" : {
				type:"edit",
				getForm:function(act,mgr){		
					var win = mgr.getSingleton("modeform");
					//win.buttons[0].disable();
					var str = _("<div>管理模式的分支统一由中心控制器管理，批量切换成管理模式，请确认以下信息：</div>") +
					/**
							_("<span>1、监控模式的分支被切换之后，除了必须要由分支控制器独立配置的配置外，分支其他配置将被中心控制器覆盖将被覆盖，请确认是否已备份配置。</span>")+
							_("<span>2、与中心控制器版本不一致的分支将被切换成维护模式。</span>") +
							_("<span>3、离线和未登录过的分支将无法切换模式。</span>");**/
					String.format('<span style="display:block;">{0}</span><span style="display:block;">{1}</span><span style="display:block;">{2}</span><span style="display:block;">{3}</span>',
						_("1、分支被切换之后，除必要独立配置外，其他配置将被覆盖，请确认是否已备份配置。"),
						_("2、与中心控制器版本不一致的分支将被切换成维护模式。"),
						_("3、离线和未登录过的分支将无法切换模式。"),
						_("4、切换认证方式无线网络需要重新配置。")
					);

					str=String.format("<div class='centralSpecial'>{0}</div>",str);
					mgr.descBox.rendered ? mgr.descBox.update(str) : mgr.descBox.html = str;					
					return win;
				},
				getOptions:function(act,mgr){
					if(act.auth ===0) {
                        act.chang_mode = "mgmt";
                    }else{
                        act.chang_mode = "center_auth";
                    }
					return {
						title:_("批量切换成管理模式")
					};
				},
				confirmAction:"changeMode.submit",
				success:"loadData"				
			},
			"p_mainten" : {
				type:"edit",
				getForm:function(act,mgr){		
					var win = mgr.getSingleton("modeform");
					//win.buttons[0].disable();
					var str = _("<div>维护模式下，中心控制器暂时不将配置下发给分支控制器，分支控制器也不能修改之前集中下发的配置，批量切换成维护模式，请确认以下信息：</div>") +
							_("<span>1、监控模式的分支被切换之后，除了必须要由分支控制器独立配置的配置外，分支其他配置将被中心控制器覆盖，请确认是否已备份配置。</span>")+
							_("<span>2、离线和未登录过的分支无法切换模式。</span>");
					str=String.format("<div class='centralSpecial'>{0}</div>",str);
					mgr.descBox.rendered ? mgr.descBox.update(str) : mgr.descBox.html = str;
					return win;
				},
				getOptions:function(act,mgr){
					
					act.chang_mode = "mainten";
					return {
						title:_("批量切换成维护模式")
					};
				},
				confirmAction:"changeMode.submit",
				success:"loadData"				
			},
			"p_monitor" : {
				type:"edit",
				getForm:function(act,mgr){		
					var win = mgr.getSingleton("modeform");
					var str = _("<div>监控模式的分支控制器独立配置自身所有的配置，中心控制器仅监控分支控制器的运行状态，批量切换成监控模式，请确认以下信息：</div>") +
							_("<span>离线和未登录过的分支无法切换模式。</span>");
					str=String.format("<div class='centralSpecial'>{0}</div>",str);
					mgr.descBox.rendered ? mgr.descBox.update(str) : mgr.descBox.html = str;
					//win.buttons[0].disable();					
					return win;
				},
				getOptions:function(act,mgr){					
					act.chang_mode = "monitor";
					return {
						title:_("批量切换成监控模式")
					};
				},
				confirmAction:"changeMode.submit",
				success:"loadData"				
			},
			"changeMode.submit":{
				type:"request",
				getOptions:function(act,mgr){
					var sels = act.grid.getSelections(), i = sels.length, rs = [],data={};
					while (i > 0){
						rs.push({id:sels[i-1].json.id,account:sels[i-1].json.account,name:sels[i-1].json.name});
						i--;
					}
					data = {
						rs:rs,
						mode:act.chang_mode
					}
					
					if(mgr.grid.selectAll){
						data.selectall = true;	
					}
					act.editingData.form.close();
					return {
						url:mgr.url,
						waitMsg : _("正在提交数据，请稍候……"),
						params:Ext.apply(data,{
							opr:"switch_branch_mode"							
						})						
					}
				},
				success:"changeMode.success",
				failure:"std.showerr"
			},
			"changeMode.success" : {
				fn:function(act,mgr){
					SF.showMsg(_("批量切换模式成功！"));
					SF.showInfo(_('中心控制器已在批量切换分支模式，此过程需耗时1-10秒，切换结果将显示在日志中。'));
					mgr.preProcessAct("loadData");
				}					
			},
			"mgmt_menu":{
				fn:function(act,mgr){
					var menu = new Ext.menu.Menu({
						items:[
							{
								text:_("进入维护模式"),
								handler:function(){
									mgr.changeMode("mgmt",act.rs[0].data.account,act.rs[0].data.id);
								}
							}
						]	
					});					
					menu.showAt(act.event.xy);				
				}				
			},
			"mainten_menu":{
				fn:function(act,mgr){
					var menu = new Ext.menu.Menu({
						items:[
							{
								text:_("进入管理模式"),
								handler:function(){
									mgr.changeMode("mainten",act.rs[0].data.account,act.rs[0].data.id);
								}
							}
						]	
					});					
					menu.showAt(act.event.xy);				
				}				
			},
			"exitCentral":{
				type:"edit",
				getForm:function(act,mgr){
					return mgr.getSingleton("exitform");					
				},				
				confirmAction:"exitCentral.submit"
			},
			"exitCentral.submit" : {
				type : "confirm",
				getMsg : function(act, mgr){
					return this.msg;
				},
				msg : _("退出集中管理，会重启服务，并会刷新您当前页面。<br/>确认是否要提交？"),
				success : "exitCentral.submit.confirm"
			},
			"exitCentral.submit.confirm":{ //退出集中监控
				type:"request",
				getOptions:function(act,mgr){
					mgr.getSingleton("exitform").hide();
					return {
						url : mgr.url,
						waitMsg : _("正在提交数据，请稍候……"),
						params : {
							opr:"switch_wac_role",
							data:{
								'wac_mode':"independ"										
							}
						}
					};				
				},
				success : "exitCentral.success",
				failure : "std.showerr"
			},
			"exitCentral.success" : {
				fn : function(act, mgr){
					SF.showInfo(_('退出集中管理成功，页面将于3秒后自动刷新'));
					mgr.getSingleton("exitform").hide();			
					(function(){
						location.href='https://'+location.host+location.pathname+'?page=pagex.system.CentralManagement';
					}).defer(3000);
				}
			},/**,
			"exitCentral":{ //退出集中监控
				fn:function(act,mgr){
					var me = this;
					
					
					SF.confirm(_("确认是否退出集中管理？"),function(btn){switch_wac_role
						if(btn==="yes"){
							var o = {
								url:"/index.php/monitor_central",
								params:{
									opr:"switch_wac_role",
									data:{
										'wac_mode':"independ"										
									}
								},
								success:function(jsonData,options){
									
								},
								failure:function(jsonData,options){
									if(jsonData.msg){
										SF.showErr(jsonData.msg);
									}
								},
								scope:me								
							};								
							Ext.Ajax.jsonRequest(o);
						}
					},this);
				}
			},**/
			"deposit.request1111":{
				type:"request",
				getOptions:function(act,mgr){
					return {
						url:mgr.url,
						params:{
							opr:"listBranchTree"
						}						
					}
				},
				success:"deposit.edit",
				failure:"deposit.edit"
			},
			"deposit.request":{
				type:"edit",
				getForm:function(act,mgr){		
					var win = mgr.getSingleton("depositform");
					win.reload();
					return win;
				},
				getOptions:function(act,mgr){					
					//var value = act.lastResult.jsonData&&act.lastResult.jsonData.data || {};
					return {
						value : {},
						disables : false,
						title : _("")
					};
				},
				confirmAction : "deposit.edit.submit"
			},
			"deposit.edit.submit":{
				type:"submit",
				getOptions:function(act,mgr){
					return {
						url : mgr.url,
						waitMsg : true,
						params : {
							opr : "deposit_branch_apcfg"
						}						
					}
				},
				success:"std.showmsg",
				failure:"std.showerr"
			},
			"slave_sso":{
				type:"request",
				getOptions:function(act,mgr){
					return {
						url:mgr.url,
						waitMsg : _("跳转中，请稍等..."),
						params : {
							opr:"get_branch_login_info",
							data : act.sso_opt						
						}
						
					}				
				},
				success:"slave_sso.success",
				failure:"std.showerr"				
			},
			"slave_sso.success":{
				fn:function(act,mgr){
					var url = location.protocol +"//"+ location.hostname + ":" + act.lastResult.jsonData.data.port+
						"?super="+act.lastResult.jsonData.data.is_super+"&token="+act.lastResult.jsonData.data.token;
						/**
					var url = "/WLAN/sso.php?msg=" + act.lastResult.jsonData.data.port+
					"?super="+act.lastResult.jsonData.data.is_super**/
					window.open(url)
				}				
			},
			//自动刷新按钮上的刷新
			"btn.refresh" : {
				forward : function (act, mgr)
				{
					//强制当做自动刷新处理，不显示表格中间的遮罩层
					act.isAutoRefresh = true;					
					var btn = act.refreshbtn, grid;					
					if(btn && act.afterAction && act.beforeAction){
						grid = act.actionCmp || mgr.grid;
						grid.store.on('datachanged', act.afterAction,act,{single:true});
						act.beforeAction();
					}					
					return "loadData";
				}
			},
			"master_sso":{
				type:"request",
				getOptions:function(act,mgr){
					return {
						url:mgr.url,
						waitMsg : _("跳转中，请稍等..."),
						params : {
							opr:"get_branch_login_info",
							data : act.sso_opt							
						}
						
					}				
				},
				success:"master_sso.success",
				failure:"std.showerr"				
			},
			"master_sso.success":{
				fn:function(act,mgr){
					var url = location.protocol +"//"+ location.hostname + ":" + act.lastResult.jsonData.data.port+
						"?super="+act.lastResult.jsonData.data.is_super+"&token="+act.lastResult.jsonData.data.token;					
					/**var url = location.protocol +"//"+ location.hostname + "/WLAN/sso.php?msg=" + act.lastResult.jsonData.data.port+
					"?super="+act.lastResult.jsonData.data.is_super;
					var url = "/WLAN/sso.php?msg=" + act.lastResult.jsonData.data.port+
					"?super="+act.lastResult.jsonData.data.is_super**/
					window.open(url);
					//alert("master_sso.success");
				}			
			},
			"newap_jump":{
				fn:function(act,mgr){
					(function(){
						SF.invoke("intelopenpage","pagex.wireless.NewAP",{branch_id:act.rs[0].id});
					}).defer(500);					
				}				
			},
			"filter":{
				type: 'edit',
				getForm : function(act, mgr){
					mgr.getSingleton("form.filter").formRoot.items.items[1].setJsonValue({})
					return mgr.getSingleton("form.filter");
				},
				confirmAction: 'filter.submit',
				failure: 'std.showerr'
			},
			"filter.submit": {
				fn: function(act, mgr) {
					var data = act.editingJsonForm.getJsonValue();
					mgr.selectAll = false;
					mgr.start = 0;
				//	mgr.filter ={};
				//	if(data.status !=2) {
						mgr.filter = data;
				//	}
					mgr.search = "";
					//mgr.sort = data.status;
					return true;
				},
				complete: 'loadData'
			},
			"add.group" : {
				type : "edit",
				getForm : function(act,mgr){
					return mgr.getSingleton("form.group");
				},
				getOptions : function(act, mgr) {
					return {
						value : {
							path:mgr.selectNode&&mgr.selectNode.store?{id:mgr.selectNode.data.id,text:mgr.selectNode.getPath("text")} :{}
						},
						disables : false,
						title : _("新增分组")
					};
				},
				confirmAction : "add.group.submit"			
			},
			"add.group.submit" : {				
				type: 'submit',
				getOptions: function(act, mgr) {
					return {						
						url: mgr.group_url,
						params: {
							opr: "add"
						}
					};
				},
				success: 'add.group.success',
				failure: 'std.showerr'
			},
			"add.group.success":{
				fn:function(act,mgr){
					var groupMenu = mgr.groupMenu,
					value  = act.lastData.jsonForm.getJsonValue(),
					newNode;
					value = Ext.apply({leaf: true, expanded: false, deletable: true, type: "bgrp"},value); 
					value.text = value.name;
					value.id = act.lastResult.jsonData.id;	
					value.pid = value.path.id;
					//{leaf: true, expanded: false, id: 1115, text: "122", deletable: true, type: "area"}
					newNode = groupMenu.createNode(value);
					var exsitNodes=groupMenu.store.data.items;
					for(var i=0;i<exsitNodes.length;i++){
						if((exsitNodes[i].id+'')===newNode.id){
							act.editingData.form.close();
							return;
						}
					}
					groupMenu.insertChild(newNode);
					groupMenu.expandNodePath(newNode.parentNode);
					groupMenu.selectNode(newNode);
					act.editingData.form.close();
				}
			},
			"modify.group.submit" : {				
				type: 'submit',
				getOptions: function(act, mgr) {
					return {
						url: mgr.group_url,
						params: {
							opr: "modify"
						}
					};
				},
				success: 'modify.group.success',
				failure: 'std.showerr'
			},
			"modify.group.success" : {
				fn:function(act,mgr){
					mgr.groupMenu.reload(function(){						
						mgr.groupMenu.expandNodePath(mgr.groupMenu.tree.getNodeById(act.node.id).parentNode);
						mgr.groupMenu.selectNode(mgr.groupMenu.tree.getNodeById(act.node.id));
					});
					act.editingData.form.close();					
				}				
			},
			'query.apgroup':{
				fn:function(act,mgr){					
					mgr.groupMenu.reload(function(){						
						mgr.groupMenu.selectNode(mgr.groupMenu.getRootNode().childNodes[0]);
					});
				}				
			},
			"modify.group" :{
				type: 'request',
				getOptions: function(act, mgr) {
					act.opr = 'modify';
					act.isEdit = true;
					return {
						waitMsg: _('正在加载编辑数据，请稍候……'),
						url: mgr.group_url,
						jsonData: {
							opr: 'listDetail',
							data: { id: act.node.id }
						}
					};
				},
				success: 'modify.edit.group',
				failure: 'std.showerr'				
			},
			"modify.edit.group" : {
				type : "edit",
				getForm : function(act,mgr){
					return mgr.getSingleton("form.group");
				},
				getOptions : function(act, mgr) {
					var valueData = act.lastResult && act.lastResult.jsonData && act.lastResult.jsonData.data;
					return {
						value : valueData,
						disables : false,
						title : _("修改分组")
					};
				},
				confirmAction : "modify.group.submit"				
			},
			"group.setting":{
				fn:function(act,mgr){
					//mgr.groupMenu.checkboxShow = !mgr.groupMenu.checkboxShow;
					mgr.showEditGropPanel();
				}
			},
			'select.all.group':{ //全选分组
				fn:function(act,mgr){
					var nodeHash = mgr.groupMenu.tree.nodeHash;
					//nodeLen = 
					for(var k in nodeHash){
						if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
							nodeHash[k].data.checked = true;					
						}
					}
					mgr.groupMenu.getView().refresh();
				}
			},
			'cancel.selectall.group':{
				fn:function(act,mgr){
					mgr.groupMenu.ischeckAll = false;
					var nodeHash = mgr.groupMenu.tree.nodeHash;
					for(var k in nodeHash){
						if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
							nodeHash[k].data.checked = false;					
						}
					}
					mgr.groupMenu.getView().refresh();
				}
			},
			'cancel.edit.group':{
				fn:function(act,mgr){
					var nodeHash = mgr.groupMenu.tree.nodeHash;
					//nodeLen = 
					for(var k in nodeHash){
						if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
							nodeHash[k].data.checked = null;					
						}
					}
					mgr.groupMenu.getView().refresh();
					mgr.showGropPanel();
					/**
					if(mgr.groupPanel.topToolbar.find('itemId','netParent')[0]){
						mgr.groupPanel.topToolbar.find('itemId','netParent')[0].setDisabled(false);
					}**/
				}
			},
			'delete.select.group': {
				type: 'confirm',
				msg: _('您确认要删除所选分支分组吗？'),
				success: 'delete.select.group.confirm',
				failure: 'std.showerr'
			},
			'delete.select.group.confirm':{
				type: 'request',
				getOptions: function(act, mgr) {
					var delList = [];
					
					var nodeHash = mgr.groupMenu.tree.nodeHash;
					//nodeLen = 
					for(var k in nodeHash){
						if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
							if(nodeHash[k].data.checked){
								//delete.selected.group.confirm
								if(!nodeHash[k].parentNode.data.checked){
									delList.push({id:nodeHash[k].data.id});
								}
							}					
						}
					}
					
					return {
						url: mgr.group_url,
						waitMsg: _('正在提交数据，请稍候……'),
						params: {
							opr: 'delete',
							delete_confirm:act.delete_confirm ? true : false,
							data: delList
						}
					};
				},
				success: 'delete.group.success',
				failure: 'std.showerr'
			},
			"delete.group.success":{
				forward:function(act,mgr){
					mgr.showGropPanel();
					return "query.apgroup";
				}				
			},
			'search.menuchange': {
				fn: function(act, mgr) {
					mgr.start = 0;
					return true;
				},
				complete: 'loadData'
			},
			"selectAll":{
				fn:function(act,mgr){
					var totalcount = mgr.getPageToolbar().totalCount;
					mgr.grid.getSelectionModel().selectAll();
					mgr.grid.updateSummary(totalcount,act.actionName);
					mgr.selectAll = mgr.grid.selectAll = true;
				}
			},
			"cancelAll":{
				fn:function(act,mgr){
					var totalcount = mgr.getPageToolbar().totalCount;
					mgr.grid.updateSummary(totalcount,act.actionName);
					mgr.grid.getSelectionModel().clearSelections();
					mgr.selectAll = mgr.grid.selectAll = false;
				}
			}
		},
		initMgr : function() {			
			this.groupMenu.on('nodeclick', this.onMenuNodeclick, this);	
			this.groupMenu.on('nodeselect', this.menuSelected, this);
			this.groupMenu.on('nodecheck', this.nodeCheck, this);			
			Mgr.superclass.initMgr.apply(this, arguments);
			this.regSingleton("netform", this.getNetForm, this);
			this.regSingleton("roleform",this.getRoleForm,this);
			this.regSingleton("synlogform",this.getSynLogForm,this);
			this.regSingleton("releasepwdform",this.getReleasePwdForm,this);
			this.regSingleton("depositform",this.getDepositForm,this);
			this.regSingleton("form.branchreview", this.createBranchListWin, this);
			this.regSingleton("form.filter", this.createFilterFormWin, this);
			this.regSingleton("modeform",this.getModeForm,this);
			this.regSingleton("form.group",this.getGroupForm,this);
			this.regSingleton("exitform",this.getExitCentral,this);
			this.regSingleton("deleteform",this.getDeleteForm,this);
			this.regSingleton("netConfigForm",this.getNetConfigForm,this);
			
			//this.regSingleton("form.deleteconfirm",this.getDeleteConfirm,this);

		},
		onSetGroup:function(){			
			this.executeAct('group.setting');	
		},
		getNetConfigForm : function(){
			var win = new B.system.CentralManagement.NetConfigWindow({
				title:_("分支独立配置"),
				width:1000,
				height:600
			});
			return win;
		},
		showEditGropPanel:function(){
			//所有 默认组不可删除
			var me = this;
			this.isGroupEditing = true;
			var nodeHash = this.groupMenu.tree.nodeHash;
				//nodeLen = 
			for(var k in nodeHash){
				if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
					nodeHash[k].data.checked = false;					
				}
			}
			this.groupMenu.getView().refresh();
			var t =  [{
					xtype:"label",
					style:"padding-left:5px",
					text: _("管理分组")
				},
				'->', {
					xtype:'button',
					text:String.format("<span class='sim-link'>{0}</span>", _('全选')),//_('全选'),
					handler:function(){
						var cancel_select = String.format('<span class="sim-link">{0}</span>', _('取消全选'));
						var select_all = String.format("<span class='sim-link'>{0}</span>", _('全选'));
						me.groupMenu.ischeckAll =!me.groupMenu.ischeckAll;
						me.executeAct(me.groupMenu.ischeckAll?"select.all.group":"cancel.selectall.group");
						this.setText(me.groupMenu.ischeckAll?cancel_select:select_all);
					}
				},'-', {
					xtype:'button',
					text:String.format('<span  class="sim-link">{0}</span>',_('返回')),//_("返回"),
					handler:function(){
						me.executeAct("cancel.selectall.group");	
						me.executeAct("cancel.edit.group");	
					}
				}
			];
			var tbItem = this.page.groupPanel.getTopToolbar();
			tbItem.removeAll();
			tbItem.add(t);
			tbItem.doLayout();
			var b =[{
				text: _('删除分组'),
				width: '100%',
				iconCls: 'sf-ico-delete',
				itemId: 'delete.select.group',
				handler: function() {
					var delList = [];					
					var nodeHash = me.groupMenu.tree.nodeHash;
					for(var k in nodeHash){
						if(nodeHash.hasOwnProperty(k)&&nodeHash[k].data&&nodeHash[k].data.deletable){
							if(nodeHash[k].data.checked){
								delList.push({id:nodeHash[k].data.id});
								me.executeAct('delete.select.group');
								return;
							}					
						}
					}
					if(delList.length===0){
						SF.alert(_("请选择需要删除的分支分组！"));
						return;
					}
					
				}
			}];
			var bbItem = this.page.groupPanel.getBottomToolbar();
			bbItem.removeAll();
			bbItem.add(b);
			bbItem.doLayout();
		},	
		getDeleteConfirm:function(){
			var win = new SF.form.FormWindow({
				width : 420,
				title:_("高级搜索"),
				form : new FilterForm()
			});
			this.addWindow(win);
			return win;
		},
		showGropPanel:function(){
			var me = this,nets = this.netGroup||[],i = nets.length,netItmes=[];			
			this.isGroupEditing = false;		
			var t = SF.invoke("sysinfo","role")=== "super" ? [
				{
					text : _("分支分组"),
					xtype:"label",
					style:"padding-left:5px"
				},

				'->', {
					text: _("&#160;"),
					iconCls: 'sf-ico-new-setting',
					handler: function() {
						me.onSetGroup();
					}
				}
			]:[
				{
					text : _("分支分组"),
					xtype:"label",
					style:"padding-left:5px"
				}
			];
			var tbItem = this.page.groupPanel.getTopToolbar();
			tbItem.removeAll();
			tbItem.add(t);
			tbItem.doLayout();
			
			var b = [{
				text: _("新增分组"),
				width: '100%',
				iconCls: 'sf-ico-add',
				itemId: 'add.group',
				handler: function() {
					me.executeAct('add.group');
				}
			}];
			
			var bbItem = this.page.groupPanel.getBottomToolbar();
			bbItem.removeAll();
			if(SF.invoke("sysinfo","role")=== "super"){
				bbItem.add(b);
			}
			bbItem.doLayout();
		},
		nodeCheck:function(tree, node, e){
			if(e){
				this.checkChild(node);
			}else{
				this.uncheckChild(node);
				this.uncheckFather(node);
			}
			tree.getView().refresh();
		},
		uncheckFather:function(node){
			for (var p = node.parentNode; (p != null)&&p.data.hasOwnProperty("checked"); p = p.parentNode){
				p.data.checked = false;
			}
		},
		checkChild:function(node){
			if(node.childNodes.length>0){
				for(var i=0;i<node.childNodes.length;i++){
					node.childNodes[i].data.checked = true;
					if(node.childNodes[i].childNodes.length>0){
						this.checkChild(node.childNodes[i]);
					}
				}
			}
		},
		uncheckChild:function(node){
			if(node.childNodes.length>0){
				for(var i=0;i<node.childNodes.length;i++){
					node.childNodes[i].data.checked = false;
					if(node.childNodes[i].childNodes.length>0){
						this.uncheckChild(node.childNodes[i]);
					}
				}
			}
		},
		menuSelected: function(tree, node, e) {			
			this.filter = this.filter || {};
			if (this.filter.advanced_search) {
				delete this.filter.advanced_search;
			}
			this.filter.id = node.id;
			this.selectNode = node;		
			this.executeAct('search.menuchange');
		},
		onMenuNodeclick : function(tree,node,e){
			var me = this;
			if(Ext.fly(e.getTarget()).hasClass('x-tree-node-edit')){
				me.preProcessAct("modify.group",{node:node},e);
			}
		},
		/**
		 * 
		 */
		ssoAction : function (type , data){ //单点登录			
			if(data.status === -1 ){
				//data.status
				SF.alert(_("该分支还没有控制器接入，无法登录到分支！"),_("错误"));
				return;
			}
			var arr = data.monitor_stat.split("/"),issj = arr[0]==="1",sso_opt, //issj是否为双机
			actionName={
				"master" : "master_sso",
				"slave": "slave_sso"
			};			
			if(type === "master" && arr[1] != 1 ){
				SF.alert(_("已与该分支断开连接，无法登录到该分支！"),_("错误"));
				return;
			}			
			if(type === "slave" && !issj ){
				SF.alert(_("该分支没有备机，无法登录到备机！"),_("错误"));
				return;
			}			
			if(type === "slave" && arr[2] != 1 ){
				SF.alert(_("已与该分支备机断开连接，无法登录到该分支备机！"),_("错误"));
				return;
			}
			sso_opt = {
				id:data.id,																		
				https_port : data.https_port
			}
			if(type === "master"){
				sso_opt.master_sso_ip = data.master_sso_ip;
			}else{
				sso_opt.slave_sso_ip = data.slave_sso_ip;				
			}
			
			this.preProcessAct(type+"_sso",{
				sso_opt : sso_opt
			});	
		},
		showBranchListWin : function (json) {
			var me = this, win = this.getSingleton("form.branchreview");
			win.open({
				value : json && json.data,
				confirm : function (form) {
					var opt = {
						url : me.url,
						waitMsg :_("正在导入数据，请稍候……"),
						params : {
							opr : 'import_confirm',
							id: form.root.fields.items[0].originalValue
						},
						scope : this,
						success : function(res, event, option, form) {
							win.hide();
							SF.showInfo(res && res.msg && 
								Ext.util.Format.htmlEncode(res && res.msg) 
								|| _("数据导入成功。"));
							
							me.executeAct("loadData");
							me.executeAct("query.apgroup");
							
							if (res && res.data.path){
								var dlwin = me.createDownloadWin();
								dlwin.open({
									value : {
										path : res.data.path
									}
								});
							}
						},
						failure : function(res,msg,op, data){
							SF.alert(res && res.msg || _("导入文件失败，请检查网络是否正常，或者点击上一步重新导入 。"));
						}
					};
					form.submit(opt);
					return false;
				}
			})
		},
		createFilterFormWin : function () {
			var win = new SF.form.FormWindow({
				width : 420,
				title:_("高级搜索"),
				form : new FilterForm()
			});
			this.addWindow(win);
			return win;
		},
		createBranchListWin : function () {
			var me = this, win = new SF.form.FormWindow({
				title : _("导入预览"),
				width : 700,
				buttonAlign : "left",
				buttons : [{
					text : _("上一步"),
					itemId: "prev",
					handler : function () {
						win.hide();
						me.executeAct("import", null, me);
					}
				}, "->",{ 
					text : _("完成"),
					itemId: "submit",
					actionName : "submit"
				},{
					text : _("取消"),
					itemId: "cancel",
					actionName : "cancel"
				}],
				form : new B.system.CentralManagement.BranchReviewForm()
			});
			this.addWindow(win);
			return win;
		},
		createImportForm : function () {
			var me = this;
			this.importWin = this.importWin || new B.ImportForm({
				width : 420,
				url : this.url,
				buttons : [{
				text : _("下一步"),
					itemId: "submit",
					actionName : "submit"
				}, {
					text : _("取消"),
					itemId: "cancel",
					actionName : "cancel"
				}],
				fieldTip : SFX.createDownloadLink('BranchList.csv', _("下载示例模板")),
				uploadFieldCfg : {
					emptyText : _('请选择正确的文件格式(*.CSV)')
				},
				fileType : 'csv',
				afterUpload : function(json) {
					if(json && json.success !== false) {
						me.showBranchListWin(json);	
						me.importWin.hide();	
					}
					
				}
			}); 
			return this.importWin;
		},
		createDownloadWin : function(){
			var win = new SFX.form.DownloadWin();
			this.addWindow(win);
			return win;
		},
		getModeForm:function(){
			var win;		
			win = new SF.form.FormWindow({
				width:450,
				buttons : [
					{
						text : _("确定"),
						actionName : "submit"
					},{
						text : _("取消"),
						actionName : "cancel"
					}
				],
				form:new SF.form.Form({
					defaults:{
						anchor:"100%"
					},
					items:[
						this.descBox = new Ext.BoxComponent({
							style:"padding-bottom:15px",
							html:"111&nbsp;"
						})
					]
				})
			});			
			return win;
		},
		changeMode:function(m,account,auth){
			var mode = {//这里发送的是当前模式，而不是切换的目标模式，虽然没有啥代码可读性，但已经这样调通了...
				"mgmt":_("管理"),
				"mainten":_("维护"),
				"monitor":_("监控")
			},me = this;
		//	var msg=_("确认是否切换成{0}模式？", mode[m]);
            if(mode[m] == _("管理")){
                var msg=_("<div>管理模式的分支统一由中心控制器管理，请确认以下信息：</div>") +
                	//_("<span>1、分支被切换之后，除了必须要由分支控制器独立配置的配置外，分支其他配置将被中心控制器覆盖，请确认是否已备份配置。</span>")
					String.format('<span style="display:block;">{0}</span><span style="display:block;">{1}</span><span style="display:block;">{2}</span><span style="display:block;">{3}</span>',
						_("1、分支被切换之后，除必要独立配置外，其他配置将被覆盖，请确认是否已备份配置。"),
						_("2、与中心控制器版本不一致的分支将被切换成维护模式。"),
						_("3、离线和未登录过的分支将无法切换模式。"),
						_("4、切换认证方式无线网络需要重新配置。")
					);
				/**
					_("<span>1、分支被切换之后，除必要独立配置外，其他配置将被覆盖，请确认是否已备份配置。</span>")+
                    _("<span>2、与中心控制器版本不一致的分支将被切换成维护模式。</span>") +
                    _("<span>3、离线和未登录过的分支将无法切换模式。</span>")+
					_("<span>4、离线和未登录过的分支将无法切换模式。</span>");**/
            }else if(mode[m] == _("维护")){
                var msg =  _("<div>维护模式下，中心控制器暂时不将配置下发给分支控制器，分支控制器也不能修改之前集中下发的配置，切换成维护模式，请确认以下信息：</div>") +
                    _("<span>1、监控模式的分支被切换之后，除了必须要由分支控制器独立配置的配置外，分支其他配置将被中心控制器覆盖，请确认是否已备份配置。</span>")+
                    _("<span>2、离线和未登录过的分支无法切换模式。</span>");
            }else if(mode[m] == _("监控")){
                var msg =  _("<div>监控模式的分支控制器独立配置自身所有的配置，中心控制器仅监控分支控制器的运行状态，切换成监控模式，请确认以下信息：</div>") +
                    _("<span>离线和未登录过的分支无法切换模式。</span>");
            }
			if(account.status!==1){
				//msg=_("该分支账号处于离线或者未登录状态，不能进行模式切换。");
				SF.showInfo(_("该分支账号处于离线或者未登录状态，不能进行模式切换。"));
				return;
			}else{
				if(account.soft_version!==SF.invoke("sysinfo","version")&&(mode[m] == _("管理"))){
                    m ="mainten";
					msg=_("该分支版本与中心控制器版本不一致，将被切成维护模式，是否进行切换？");
				}
			}
			msg=String.format("<div class='centralSpecial'>{0}</div>",msg);
			
			Ext.MessageBox.show({
				title : _('请确认'),
				msg : msg,
				buttons : Ext.MessageBox.OKCANCEL,
				icon: null,
				fn : function(btn){
					if(btn === "ok"){
                        if(auth){
                            m = "center_auth";
                        }
						this.page.mgr.changedMode=m;
						var o = {
							url:"/index.php/monitor_central",
							params:{
								opr:"switch_branch_mode",
								rs:[{'account':account.account,'id':account.id,'name':account.name}],
								mode:m
							},
							success:function(jsonData,options){
								var currentSelecttion=this.page.mgr.grid.selModel.selections.items[0];
								if(currentSelecttion!=undefined&&currentSelecttion!=''){	
									
									currentSelecttion.json.mode=m;									
								}
								this.page.mgr.grid.view.refresh();
								this.page.mgr.grid.topToolbar.find('xtype','splitbutton.refresh')[0].stopAutoRefresh();
								this.page.mgr.grid.enableAutoRefresh.defer(10000,this,[]);
							},
							failure:function(jsonData,options){
								if(jsonData && jsonData.msg){
									SF.alert(jsonData.msg);
								}else if(jsonData && jsonData.noPermission){
								}else{
									SF.alert(_('模式切换失败，该分支正处于离线状态或者对应的版本与中心控制器不一致'));
								}
								
							},
							scope:me								
						};								
						Ext.Ajax.jsonRequest(o);
					}
				},
				scope : this
			});
			//SF.confirm(msg, , this);		
		},		
		getDepositForm:function(){
			var win;
			var State = SFX.tree.tristate.State;
			var me=this;
			var onRequestSuccess = SFX.tree.tristate.Loader.prototype.onRequestSuccess;
			var Tree=this.tree = new SFX.tree.tristate.TreePanel({
								searchable: true,
								autoLoadTree: this.autoLoadTree,
								rootVisible: true,
								name:"deposit",
								initTree: function() {
									if (!this.tree) {
										this.tree = new SFX.tree.tristate.Tree(new SFX.tree.tristate.NodeParentNoSall(Ext.apply({
											id: "root",
											path: "/",
											name: "/",
											noAllot:"2",
											leaf: false
										}, this.root)));
									}
								},
								setJsonValue : function(value){
									var value = this.valueConvertor.decode(value);
									this.getTree().setJsonValue(value);
								},
								treeCols: [new SF.tree.TreeColumn({
								dataIndex: "name",
								renderer: function(value, metaData, record, rowIdx, colIdx, store) {
									value = value.replace(/\n\n/g, "/"); //php对特殊字符\进行处理。
									var node = store.getNode(record),
										data = node.data,
										state = node.getCheckState(),
										checkboxCls = "sf-selectors-grouptree-checkbox",
										checkboxClsPrefix = checkboxCls + "-";
									var checkboxStrStart = '<div role="checkbox" class="x-gridtree-img ' + checkboxCls + ' ',
										checkboxStrEnd = '"  /></div>',
										nodeIconStr = "",
										groupIconStrStart = '<div style="margin-left:3px" class="x-gridtree-img ',
										groupIconStrEnd = '"></div>';
									if (data.checkable === false) {
										return value;
									}
									switch (state) {
										case State.False:
											checkboxCls = checkboxClsPrefix + "none";
											break;
										case State.Both:
											checkboxCls = checkboxClsPrefix + "part";
											break;
										case State.True:
											checkboxCls = checkboxClsPrefix + "all";
											break;
									}
									if (data.id === 'root') {
										nodeIconStr = '';
									} else if (data.type === 'branch') {
										if(data.id==0){
											nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-icon-central' + groupIconStrEnd;
										}else{
											nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-icon-net' + groupIconStrEnd;
										}
									}else if (data.type === 'ap') {
										nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-new-apleaf' + groupIconStrEnd;
									}else if (data.type === 'bgrp') {
										nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico aplist-bgrp' + groupIconStrEnd;
									} else if (data.type === 'grp'||data.type === 'bgrp') {
										if(data.is_branch){
											nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-icon-net' + groupIconStrEnd;
										}else if(data.is_area){										
											nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-new-aparea' + groupIconStrEnd;
										}else{
											nodeIconStr = groupIconStrStart + 'sf-tpl-menuview-item-ico sf-ico-new-apgroup' + groupIconStrEnd;
										}
									}
									if(data.noAllot === "1")
										return checkboxStrStart + checkboxCls + checkboxStrEnd + nodeIconStr+ 
										String.format("<span title='{1}' class='using'>{0}</span>", 
										Ext.util.Format.htmlEncode(value), _(value + _("在") + self.apobj[data.id]["name"] + _("中被引用")));
									if(data.id===0&&data.type==='branch'){
										return checkboxStrStart + checkboxCls + checkboxStrEnd + nodeIconStr+ 
										String.format("<span title='{1}{2}' class='using'>{0}</span>",
										Ext.util.Format.htmlEncode(value),value,_("(中心控制器包含所有区域和托管的AP)"));
									}
                                    if(data.auth_type===1&&data.type==='branch'){
                                        //var des = String.format("<span style='color:red' title='" + _("{0}以集中认证加入集中管理，中心控制器自动托管分支AP") + "'>(" + _("{0}以集中认证加入集中管理，中心控制器自动托管分支AP") + ")</span>", data.name);
                                        //var des = _("{0}已开启分布式认证，中心控制器自动托管分支AP",data.name);
                                        return checkboxStrStart + checkboxCls + checkboxStrEnd + nodeIconStr+
                                            String.format("<span title='{1}' class='using'>{0}</span>",
                                                Ext.util.Format.htmlEncode(value),value);
                                    }
									return checkboxStrStart + checkboxCls + checkboxStrEnd + nodeIconStr+ String.format("<span title='{1}'>{0}</span>",
									Ext.util.Format.htmlEncode(value), value);
								}
							})],
							nodeLoader: new SFX.tree.tristate.Loader({
								url: '/index.php/monitor_branch_area',
								opr: "query_mgmt_branch_tree",
								parseNodes: function(datas, basePath){
									var nodes = [], i, data, node, path;
									if(basePath === "/"){
										basePath = "";
									}
									if(datas.tree){
										if(datas.tree[0].type=="bgrp"){
											me.tree.root.id=datas.tree[0].id;
											me.tree.root.type=datas.tree[0].type;
											me.tree.root.name=datas.tree[0].name;
											me.tree.store.data.get(0).set('name',datas.tree[0].name);
											me.tree.store.data.get(0).set('id',datas.tree[0].id);
											me.tree.store.data.get(0).set('type',datas.tree[0].type);
											if(datas.tree[0].checked){
												me.tree.tree.root.setJsonValue({
														selectAll : true
													}, true);
											}
											datas=datas.tree[0].children;
										}else{
											datas=datas.tree;
										}
										
									}
									for(i=0; i<datas.length; i++){
										data = datas[i];
										path = basePath + "/" + data.name;
										node = {
											id : data.id,
											path : path,
											text : data.name,
											name : data.name,
											leaf : data.leaf,
											type : data.type,
											noAllot : data.noAllot,
											selectAll : data.checked,
											checkable : true,
                                            auth_type:data.auth_type,
                                            is_branch:data.is_branch,
											is_area:data.is_area
										};
										if(data.children){ // 有可能存在一次性增加整个树的情况
											node.children = this.parseNodes(data.children, path);
										}
										nodes.push(node);
									}
									return nodes;
								},
								onRequestSuccess: function(jsonData, options) {
									var _this = this,arg = arguments;
									onRequestSuccess.apply(_this, arg);		
								}
							}),
							root: {
								id: "root",
								path: "/",
								noAllot:"2",
								checkable: true,
								type: "root",
								name: _("全部")
							}
						});
			
			SF.applyInterface(Tree, SF.form.JsonField);
			var panel =  new Ext.Panel({
				split: true,
				region : "center",
				layout : "fit",
				width: 320,
				height:250,
				//border:false,
				minWidth : 240,
				//title : _("可选"),
				items : [this.tree]
			});
			win = new SF.form.FormWindow({
				width:400,
				height:320,				
				title:_("托管分支"),	
				defaults:{
					anchor:"100%"
				},
				form:new SF.form.Form({
					items:[
						{										
							xtype : "box",
							region:"north",
							style : "margin-bottom:5px;",
							html : _("分支控制器故障时，分支接入点将托管给中心控制器进行管理，托管下的分支终端认证都在中心控制器完成。")+"<Br/>"+
								   _("请选择需要在故障时进行托管的分支控制器。")+"<Br/>"
						},						
						panel
					]				
				}),				
				reload:function(){
					this.items.items[0].items.items[1].items.items[0].reload();
				}
			});
			return win;
		},
		getReleasePwdForm:function(){
			var win;
			win = new SF.form.FormWindow({
				width:500,
				title:_("解控密码设置"),
				form:new B.system.CentralManagement.ReleasePwdForm(),
				buttons:[] //不要确认按钮
			});
			return win;
		},
		getSynLogForm:function(){
			var win;
			win = new SF.form.FormWindow({
				width:450,
				from : new SF.form.Form({})
			});
			return win;
		},
		getRoleForm	: function(){
			var win;
			win = new SF.form.FormWindow({
				width:450,
				form : new B.system.CentralManagement.RoleForm()
			});
			return win;
		},
		getGroupForm : function(){ //分支分组
			var win;
			win = new SF.form.FormWindow({
				width:450,
				form : new B.system.CentralManagement.BranchGroupForm()
			});
			return win;
		},
		getDeleteForm : function(){
			var win;		
			win = new SF.form.FormWindow({
				width:350,
				title:_("确认删除分支"),
				form:new SF.form.Form({
					defaults:{
						anchor:"100%"
					},
					labelWidth:80,
					items:[
						this.descBox = new Ext.BoxComponent({
							style:"padding-bottom:15px;line-height:20px",
							html:_("删除分支之后，中心控制器将不能管理分支控制器，请确认是否删除所选分支？")
						}),
						{
							xtype : "checkbox",
							name: "desc",
							htype :true,
							hideLabel:true,
							boxLabel:_("确定删除所选分支"),
							listeners:{
								"check":function(box,value){
									if(value){
										win.buttons[0].enable();
									}else{
										win.buttons[0].disable();
									}
								}
							}
						}
					]
				}),
				buttons:[{
					text : _("确定"),
					disabled:true,
					itemId: "submit",
					actionName : "submit"
				}, {
					text : _("取消"),
					itemId: "cancel",
					actionName : "cancel"
				}]
			});			
			return win;
		
		},
		getExitCentral:function(){ //退出集中管理
			var win;		
			win = new SF.form.FormWindow({
				width:350,
				title:_("确认中心控制器退出集中管理"),
				form:new SF.form.Form({
					defaults:{
						anchor:"100%"
					},
					labelWidth:80,
					items:[
						this.descBox = new Ext.BoxComponent({
							style:"padding-bottom:15px;line-height:20px",
							html:_("中心控制器退出集中管理后将清除控制器中的分支配置，请确认已备份配置？")
						}),
						{
							xtype : "checkbox",
							name: "desc",
							htype :true,
							hideLabel:true,
							boxLabel:_("已备份配置，确认退出集中管理"),
							listeners:{
								"check":function(box,value){
									if(value){
										win.buttons[0].enable();
									}else{
										win.buttons[0].disable();
									}
								}
							}
						},{
							xtype : "linkreffield",
							id:"branchlink",
							text : _("如果尚未备份，请点击此处备份配置"),
							htype :true,
							hidden : true,
							openWindow : function () {
								SF.invoke("openhtml","/WLAN/index.php?page=pagex.maintain.Backup",{}, true);
								
							}
						}
					]
				}),
				buttons:[{
					text : _("确定"),
					disabled:true,
					itemId: "submit",
					actionName : "submit"
				}, {
					text : _("取消"),
					itemId: "cancel",
					actionName : "cancel"
				}]
			});			
			return win;
		},
		getNetForm : function() {
			var win;
			var validation = new SFX.validations.Psw();
			var validationPwdDiff = function(v, username) {
				var numreg = /^[\d]*$/, creg = /^[a-z]*$/i, screg = /^[^a-z\d]*$/i;
				if (v) {
					if ((username && v.indexOf(username) > -1)
							|| v.length < 8
							|| (numreg.test(v) || creg.test(v) || screg.test(v))) {
						return _("不能包含用户名，最小长度为8位，必须同时包含字母/数字/字符中的两种");
					}
					return true;
				}
			};
			win = new SF.form.FormWindow({
				title : _("添加"),
				width : 400,
                closeAction:'close',
				form : new SF.form.Form({
					items : [							
						{
							xtype:"hidden",name:"id"
						},
						{
							xtype : "nametextfield",
							name : "name",
							maxLength : 95,
							allowBlank : false,
							fieldLabel : _("分支名"),
							width : '80%'
						}, {
							xtype : "textfield",
							name : "account",
							allowBlank : false,
							fieldLabel : _("账号"),
							width : '80%',
							minLength : 6,
							maxLength:95,
							regex : /^[a-zA-Z][a-zA-Z0-9_]*$/,
							regexText : _("必须是以英文字母开头的英文、下划线和数字的组合，可以是纯英文字母")
						}, {
                            xtype: 'panel',
                            layout: 'column',
                            width:"100%",
                            border: false,
                            style:"margin-bottom:5px;",
                            items: [
                           		{										
									xtype : "box",
									width:105,
									html : _("密码：")
								},
	                            {
									xtype :"passwordtextfield",
		                           	name:"pwd",
									id:'password',
                                    fieldLabel : _("密码"),
		                            width:212,
		                            allowBlank : false,
		                            inputType : "password",
		                            minLength : 1,
									maxLength : 25
								}
                            ]
                        },
						new B.system.CentralManagement.BranchGroupCombo({
							name : 'path',
							allowBlank : false,
							width:212,
							branchObj:this.branchObj,
							fieldLabel : _('所属组')
						})
				]
				})

			});

			return win;
		}
	});

	Ext.ns("B.system.CentralManagement");
	B.system.CentralManagement.CentralMgr = Mgr;
})();