<?php if (!defined('BASEPATH'))
    exit('No direct script access allowed');

/**
 * 对象定义-认证页面
 * @qwl
 * 2012-12-3
 */
class Obj_auth extends SF_Controller {

    const PIC_SIZE=2000;  //图片大小
    const TMP_PIC_PATH='/tmp/ci/temp/';  //图片大小
    const UI_PIC_PATH='/wns/webui/tmppic/';  //支持前端访问的图片路径
    const TMP_WEB_PIC_PATH='/tmppic/';  //图片大小
    /**
     * construct
     */
    public function __construct() {
        parent::__construct();

        try {
            $this->_load_model('obj_auth_model');
        } catch (Exception $e) {
            $this->log->add('debug', $e->__toString());
            $this->log->add('error', $e->getMessage());
            $this->log->flush();
        }
    }

    /**
     * 加载model
     */
    protected function _load_model($name, $alias = 'model') {
        $this->load->model('object_configure/auth/'.$name, $alias);
    }

    /**
     * list
     */
    public function index() {
        $form = $this->_get_query_form();

        if ($this->model->assert_form($form, 'index')) //表单断言
            {
            $rs = $this->model->index(); //查询
            $ret['data'] = $this->_process_query_result($rs); //对查询结果进行处理
            $this->_change_data($ret['data']);
            $ret['total'] = $this->model->gettotalcnt() -1 ; //有个802.1x的记录被隐藏了，要减去1；
            $this->log->flush($ret);

        } else {
            $this->log->flush();
        }
    }

    /**
     * 处理form表单兼容新增的全屏显示竖向广告模板
     * @zhangjie
     */
    protected function deal_ui_form(&$data) {

        if(isset($data['effectFieldset']['portalText']))
        {
            if(isset($data['effectFieldset']['portalText']))
                $data['portalText'] = $data['effectFieldset']['portalText'];
            if(isset($data['effectFieldset']['bgColor']))
                $data['bgColor'] = $data['effectFieldset']['bgColor'];
            if(isset($data['effectFieldset']['disclaimer']))
                $data['disclaimer'] = $data['effectFieldset']['disclaimer'];
            $data['opacity'] = intval($data['effectFieldset']['opacity']);
            unset($data['effectFieldset']);
        }
/*        if(isset($data['adFieldset']['adImgFieldset']['adImgs']))
        {
            $data['adFieldset']['adImgs'] = $data['adFieldset']['adImgFieldset']['adImgs'];
            unset($data['adFieldset']['adImgFieldset']['adImgs']);
        }*/
        if(isset($data['logoCt']['logoImg']))
        {
            $data['logoImg'] = $data['logoCt']['logoImg'];
            unset($data['logoCt']);
        }
        if(isset($data['bgCt']['bgImg']))
        {
            $data['bgImg'] = $data['bgCt']['bgImg'];
            unset($data['bgCt']);
        }
        return;
    }
    
    /**
     * 新增
     */
    public function add() {
        $this->_reject_slave_wac_opr();

        $form = $this->_get_query_form();
        //处理form表单兼容新增的全屏显示竖向广告模板
        //$this->deal_ui_form($form['data']);
        if ($this->model->assert_form($form, 'create')) //表单断言
            {
            $rs = $this->model->create();
            $this->log->flush();
        } else {
            $this->log->flush();
        }
    }

    /**
     * 修改
     */
    public function modify() {
        $this->_reject_slave_wac_opr();

        $form = $this->_get_query_form();
        //处理form表单兼容新增的全屏显示竖向广告模板
      //  $this->deal_ui_form($form['data']);
        if ($this->model->assert_form($form, 'update')) //表单断言
            {
            $rs = $this->model->update();
            $this->log->flush();
        } else {
            $this->log->flush();
        }
    }
    /**
     * 删除
     */
    public function delete() {
        $this->_reject_slave_wac_opr();

        $form = $this->_get_query_form();
        if ($this->model->assert_form($form, 'delete')) //表单断言
            {
            $rs = $this->model->delete();
            $this->log->flush($rs);
        } else {
            $this->log->flush();
        }
    }

    /**
     * 详细
     */
    public function listDetail() {
        $form = $this->_get_query_form();
        if ($this->model->assert_form($form, 'detail')) //表单断言
            {
            $rs = array($this->model->detail()); //详细查询
            $this->_change_data($rs, '_detail_map');
            $ret['data'] = $rs[0];
            $this->log->flush($ret);
        } else {
            $this->log->flush();
        }
    }

    public function detailFallstream()
    {
        $form = $this->_get_query_form();
        if($this->model->assert_form($form,'detailFallStream'))
        {
            $rs = array($this->model->detail());
            $this->_change_data($rs,'_detail_fallstream');
            $ret['data'] = $rs[0];
            $this->log->flush($ret);
        }
        $this->log->flush();
    }

    public function _detail_fallstream(&$record =array())
    {
        $this->model->_detail_fallstream($record);
    }
    /**
     * 获取临时图片路径
     */
    public function getImagePath() {
        $form = $this->_get_query_form();
        if ('pc'===$form['data']['type'])
        {
            $picName = get_picture($form['data']['id'],
                $form['data']['name'], self::TMP_PIC_PATH,
                array(self::PIC_SIZE, self::PIC_SIZE),
                1 * 1024 * 1024, array('jpg', 'gif', 'png', 'jpeg'), false,false);
        }else
        {
            $picName = get_picture($form['data']['id'],
                $form['data']['name'], self::TMP_PIC_PATH,
                array(self::PIC_SIZE, self::PIC_SIZE),
                0.5 * 1024 * 1024, array('jpg', 'gif', 'png', 'jpeg'), false,false);
        }

        copy_file(self::TMP_PIC_PATH.$picName, self::UI_PIC_PATH.$picName);
        $ret['data'] = self::TMP_WEB_PIC_PATH . $picName;
        $this->log->flush($ret);
    }

    /**
     * 前端list方法的映射表
     *
     * @param        $record        array        当前正在处理的记录
     * @return        array
     */
    public function _list_map(&$record = array()) {
        //供子类定制
        if (empty($record)) {
            return array();
        }
        $cited = $this->model->is_cited($record['id']) ? 1 : 0;
        if(isset($record['type'])) {
            $type = $this->model->type2json($record['type']);
        } else {
            $type = '';
        }
//        if(isset($record['is_template']) && $record['is_template']) { //td30003：新版本兼容老版本，可统一为一种预览方式
            
            $url = 'https://'.trim($_SERVER['HTTP_HOST'], '/').'/portal/'.'preview.html?id='.$record['folder_id'];
//        } else {
//            $ispcmobile = $this->model->ispcmobile($record['folder_id']);
//            $url = $ispcmobile ?  strval($record['folder_id']) : 'https://'.trim($_SERVER['HTTP_HOST'], '/').'/portal/'.$record['folder_id'].'/login.html';
//        }
        //默认模板中英文名字转换
        $data = array(
            'id'      => $record['id'],
            'name'    => $record['is_default']?__($record['name']):$record['name'],
            'desc'    => isset($record['desc']) ? $record['desc'] : '',
            'type'    => $type,
            'cited'   => $cited,
            'url'     => $url, 
            'default' => $record['is_default'],
            'creator' => isset($record['creator'])? $record['creator'] : super_admin(),
        );
        $record = $data;
        return true;

    }


    /**
     * 前端listDetail方法的映射表
     *
     * @param        $record        array        当前正在处理的记录
     * @return        array
     */
    protected function _detail_map(&$record = array()) {
        //供子类定制
        if (empty($record)) {
            return array();
        }
        if(isset($record['type'])) {

            $type = $this->model->type2json($record['type']);
        } else {
            $type = '';
        }
        $marketadmin = array();
        if(isset($record['market_admin_all']) && $record['market_admin_all'])
        {
            $marketadmin[] = array('id'=>-1, 'name'=>'全部');
        }
        elseif(isset($record['market_admin']) && !empty($record['market_admin']))
        {
            $this->load->model('system_management/admin_account/admin_account_model');
            $ret = $this->admin_account_model->get_market_adminlist();
            foreach($record['market_admin'] as $mkadmin)
            {
                if(isset($ret[$mkadmin]))
                    $marketadmin[] = $ret[$mkadmin];
            }
        }
        $languge = array('English', __('中文'));
        $pccssfile = '/wns/etc/config/portal/'.$record['folder_id'].'/pc.css';
        $pcstyle = read_file($pccssfile);
        $mobilecssfile = '/wns/etc/config/portal/'.$record['folder_id'].'/mobile.css';
        $portal_dir = '/wns/etc/config/portal/'.$record['folder_id'];
        $mobilestyle = read_file($mobilecssfile);
        $ads = array();
        if(!empty($record['ads'])) {
            foreach($record['ads'] as $ad) {
                $ads[] = array(
                
                 'title' => $ad['name'],
                 'link' => isset($ad['url']) ? $ad['url'] : '',
                 'adImg' => array(
                    'name' => isset($ad['ori_name']) ? $ad['ori_name'] : '',
                    'id'   => '',
                 ),
                 //全屏竖向广告新增的字段
                 'adImgPc' => array(
                    'name' => $name =isset($ad['ori_name']) ? $ad['ori_name'] : '',
                     'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$name,
                    'id'   => '',
                 ),
                 'adImgPhone' => array(
                    'name' => $name_ph = isset($ad['ori_name_phone']) ? $ad['ori_name_phone'] : '',
                     'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$name_ph,
                    'id'   => '',
                 )                       
                   
                );
            }
        } 
        if ($type !== 'fullscreen') {
            $record = $this->_translate_portal_text($record);
        }
        $portal_text_zh =$this->get_portal_text($record);
        $portal_text_en =$this->get_portal_text($record,'en');
        $logofile = glob($portal_dir.'/res/img/logo.*');
        $logoname = '';
        if(isset($logofile[0])&&file_exists($logofile[0])){
            $logoname = basename($logofile[0]);
        }

        $data = array(
            'logoImg'=>array(
                'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$logoname,
            ),
    
            'adFieldset' => array(
                'adImgs' => $ads,
            ),
            'ad_show' => array(
                'adImgs' => $ads,
            ),
            'bgColor' => array(
                'color' => isset($record['backgroud_colour']) ? $record['backgroud_colour'] : '',
                'type' => isset($record['backgroud_colour_type']) ? $record['backgroud_colour_type'] : 'system',
                'pcStyle' => $pcstyle,
                'mobileStyle' => $mobilestyle,
            ),
            
            'desc' => isset($record['desc']) ? $record['desc'] : '',
            'disclaimer' => array(
                'allow' => !empty($record['disclaimer_enable']) ? true : false,
                'content' => isset($record['disclaimer']) ? $record['disclaimer'] : '',
                'enable' => isset($record['has_disclaimer']) ? $record['has_disclaimer'] : false,
            ),
            'name' => $record['is_default'] ? __($record['name']) : $record['name'],
            'pagetitle' => isset($record['title']) ? $record['title'] : '',
            'id' => $record['id'],
            'type' => $type,
             'market_permission' => $marketadmin,
            'portalText' => $portal_text_zh
        );
        if($type === 'fullscreen')
        {
            $data['disclaimer']['content_en'] = isset($record['disclaimer_en'])?$record['disclaimer_en']:'';
            $data['effectFieldset'] = array(
                'deft_lang' => isset($record['def_lang']) ? (\wns\language_type_e::LN_CHINESE === $record['def_lang']) ? 'zh' : 'en' : 'zh',
                'opacity' => isset($record['transparency']) ? $record['transparency'] : 80,
                'portalText' =>array(
                    'ch_des'=>$portal_text_zh,
                    'en_des'=>$portal_text_en,
                    'language'=>'simple_chn'
                ),
                'bgColor' => $data['bgColor'],
                'disclaimer' => $data['disclaimer'],
                'logoImg'=>array(
                    'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$logoname,
                ),
                'icon'=>array(
                    'img'=>array(
                        'id'=>'',
                        'name'=>isset($record['qr_icon'])?$record['qr_icon']:'',
                    ),
                ),
            );
            $data['ad_show']['forceAd']['enable'] = isset($record['force_ad']) ? $record['force_ad'] : true;

            $data['ad_show']['forceAdOut']['enable'] = isset($record['force_ad']) ? $record['force_ad'] : true;
            $data['ad_show']['forceAdOut']['ref_time'] = isset($record['force_ad_time']) ? $record['force_ad_time'] : 10;

            $data['ad_show']['enable'] = isset($record['no_ad']) ? $record['no_ad'] : false;
            $data['ad_show']['forceAd']['ref_time'] = isset($record['force_ad_time']) ? $record['force_ad_time'] : 10;
            $data['ad_show']['adUrl'] = isset($record['ad_link']) ? $record['ad_link'] : '';
            $data['ad_show']['enableUrl'] = isset($record['ad_show_type'])&&
                    $record['ad_show_type'] ===\wns\ad_show_type_e::SHOW_AD_FROM_OTHER_WEB ? true : false;
             $data['ad_show']['enableImg'] =!$data['ad_show']['enableUrl'];
            $data['ad_show']['dataDelay']['enable'] = $record['ad_poll_enable'];
            $data['ad_show']['dataDelay']['delay_time'] = $record['ad_poll_time'];
        }
        $record = $data;
        
        
    }
    private function get_portal_pic_name($pic_name,$portal_dir){
        $picfile = glob($portal_dir.'/res/img/'.$pic_name.'.*');
 
        if(isset($picfile[0])&&file_exists($picfile[0])){
            return basename($picfile[0]);
        }
        return '';
    }

    private function  get_portal_text($record,$lang='zh'){
        switch ($lang){
            case 'en':
                $key = 'portal_text_en';
                //td58681 代码逻辑错误导致英文模式下保存了中文默认配置，这里强制返回英文。
                if(isset($record[$key]['qrcode_check_desc']) &&
                    '您正在对终端<MAC>进行授权，请确认是否继续进行授权?' === $record[$key]['qrcode_check_desc'])
                {
                    unset($record[$key]['qrcode_check_desc']);
                }
                $default_qr_check = 'You are to authorize the guest (&lt;MAC&gt;). Would you like to proceed?';
                $attention_desImg = 'attention_desImg_en';
                $attention_gzImg = 'attention_gzImg_en';
                $iwant_desImg = 'iwant_desImg_en';
                $iwant_iwImg = 'iwant_iwImg_en';                
                break;            
            case 'zh':
            default :
                $default_qr_check = '您正在对终端&lt;MAC&gt;进行授权，请确认是否继续进行授权?';
                $key = 'portal_text';
                $attention_desImg = 'attention_desImg';
                $attention_gzImg = 'attention_gzImg';
                $iwant_desImg = 'iwant_desImg';
                $iwant_iwImg = 'iwant_iwImg';              
                break;  
        }
        $portal_dir = '/wns/etc/config/portal/'.$record['folder_id'];        
        $portalText = array(
                'accountTab' => array(
                    'accountTabTitle' => isset($record[$key]['account_tab_title']) ? $record[$key]['account_tab_title'] : '',
                    'accountTabDesc' => isset($record[$key]['account_tab_desc']) ? $record[$key]['account_tab_desc'] : '',
                    'accountLoginText' => isset($record[$key]['account_tab_btn']) ? $record[$key]['account_tab_btn'] : ''
                
                ),
                'smsTab' => array(
                    'smsTabTitle' => isset($record[$key]['sms_tab_title']) ? $record[$key]['sms_tab_title'] : '',
                    'smsTabDesc' => isset($record[$key]['sms_tab_desc']) ? $record[$key]['sms_tab_desc'] : '',
                    'smsLoginText' => isset($record[$key]['sms_tab_btn']) ? $record[$key]['sms_tab_btn'] : '',
                
                ),
                'guestTab' => array(
                
                    'guestTabTitle' => isset($record[$key]['guest_tab_title']) ? $record[$key]['guest_tab_title'] : '',
                    'guestTabDesc' => isset($record[$key]['guest_tab_desc']) ? $record[$key]['guest_tab_desc'] : '',
                    'guestLoginText' => isset($record[$key]['guest_tab_btn']) ? $record[$key]['guest_tab_btn'] : '',
                    
                ),
                'submitBtnText' => isset($record[$key]['submit_btn_text']) ? $record[$key]['submit_btn_text'] : '',
                'getSmsCodeBtnText' => isset($record[$key]['get_sms_code_btn_text']) ? $record[$key]['get_sms_code_btn_text'] : '',
                'copyright' => isset($record[$key]['copyright']) ? $record[$key]['copyright'] : '',
                'qrCodeTab' => array(
                    'qrCodeTabDesc' => isset($record[$key]['qrcode_tab_desc']) ? $record[$key]['qrcode_tab_desc'] : '',
                    'qrCodeTabInfo' => isset($record[$key]['qrcode_tab_info']) ? $record[$key]['qrcode_tab_info'] : '',
                    'qrCodeTabTitle' => isset($record[$key]['qrcode_tab_title']) ? $record[$key]['qrcode_tab_title'] : '',
                    'qrcode_check_desc' =>[
                        'content' =>  isset($record[$key]['qrcode_check_desc']) ? $record[$key]['qrcode_check_desc'] : $default_qr_check,
                    ],
					'qrcode_check_info' => (isset($record[$key]['is_must_fill']) && $record[$key]['is_must_fill']) ?  'required' : 'optional',
					'required' => isset($record[$key]['is_must_fill']) ? $record[$key]['is_must_fill'] : false,
                ),
                'webchatTab' => array(
                'wxTabDesc' => isset($record[$key]['wechat_tab_desc']) ? $record[$key]['wechat_tab_desc'] : '',
                'wxAccount' => isset($record[$key]['wechat_tab_account']) ? $record[$key]['wechat_tab_account'] : '',
                'wxTabTitle' => isset($record[$key]['wechat_tab_title']) ? $record[$key]['wechat_tab_title'] : '',
                //微信高级配置
                'advance' => array(
                    'iwant' => array(
                        'enable' => isset($record[$key]['wechat_info_set']['qr_code_tips_enable']) ?
                                $record[$key]['wechat_info_set']['qr_code_tips_enable'] : false,
                        'des_text' => isset($record[$key]['wechat_info_set']['qr_code_desc_text']) ?
                                $record[$key]['wechat_info_set']['qr_code_desc_text'] : '',
                        'self'=>array(
                            'enable' => isset($record[$key]['wechat_info_set']['qr_code_desc_img_user_def']) ?
                                !$record[$key]['wechat_info_set']['qr_code_desc_img_user_def'] : false,
                        ),
                        'desImg'=>array(
                            'id'=>'',
                            'name'=>($tmp_name=$this->get_portal_pic_name($iwant_desImg,$portal_dir)),
                            'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$tmp_name,
                        ),
                        'iwImg'=>array(
                            'id'=>'',
                            'name'=>($tmp_name=$this->get_portal_pic_name($iwant_iwImg,$portal_dir)),
                            'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$tmp_name,
                        )                        
                    ),
                    'attention' => array(
                        'enable' => isset($record[$key]['wechat_info_set']['attention_tips_enable']) ?
                                $record[$key]['wechat_info_set']['attention_tips_enable'] : false,
                        'des_text' => isset($record[$key]['wechat_info_set']['attention_desc_text']) ?
                                $record[$key]['wechat_info_set']['attention_desc_text'] : '',
                        'desImg'=>array(
                            'id'=>'',
                            'name'=>($tmp_name=$this->get_portal_pic_name($attention_desImg,$portal_dir)),
                            'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$tmp_name,
                        ),
                        'gzImg'=>array(
                            'id'=>'',
                            'name'=>($tmp_name=$this->get_portal_pic_name($attention_gzImg,$portal_dir)),
                            'imgUrl'=>'/portal/'.$record['folder_id'].'/res/img/'.$tmp_name,
                        )                          
                    ),                    
                )
            ),
                'nouserTab' => array(
                    'nouserTabDesc' => isset($record[$key]['nouser_tab_desc']) ? $record[$key]['nouser_tab_desc'] : '',
                    'nouserTabTitle' => isset($record[$key]['nouser_tab_title']) ? $record[$key]['nouser_tab_title'] : '',
                    'nouserLoginText' => isset($record[$key]['nouser_tab_btn']) ? $record[$key]['nouser_tab_btn'] : '',
                ),
                'facebookTab' => array(
                    'facebookTabTitle' => isset($record[$key]['facebook_tab_title']) ? $record[$key]['facebook_tab_title'] : '',
                    'facebookLoginText' => isset($record[$key]['facebook_tab_desc']) ? $record[$key]['facebook_tab_desc'] : '',
                ),
                'facebook_icon'=>isset($record[$key]['facebook_desc_text']) ? $record[$key]['facebook_desc_text'] : '',
                'srufing' => isset($record[$key]['netplay_btn_text']) ? $record[$key]['netplay_btn_text'] : '',
                'disclaimer_link_text' => isset($record[$key]['disclaimer_link_text']) ? $record[$key]['disclaimer_link_text'] : '',
                'other_desc' => isset($record[$key]['other_method_desc']) ? $record[$key]['other_method_desc'] : '',
                'sms_icon' => isset($record[$key]['sms_icon_desc_text']) ? $record[$key]['sms_icon_desc_text'] : '',
                'wx_icon' => isset($record[$key]['wechat_icon_desc_text']) ? $record[$key]['wechat_icon_desc_text'] : '',
                'db_tmp_icon' => isset($record[$key]['account_icon_desc_text']) ? $record[$key]['account_icon_desc_text'] : '',
                'qrcode_icon' => isset($record[$key]['qrcode_icon_desc_text']) ? $record[$key]['qrcode_icon_desc_text'] : '',
                'no_verify_icon' => isset($record[$key]['nouser_icon_desc_text']) ? $record[$key]['nouser_icon_desc_text'] : '',
                'acnt_icon' => isset($record[$key]['acnt_icon_desc_text']) ? $record[$key]['acnt_icon_desc_text'] : ''
            );        
        return $portalText;        
    }

    /**
     * 提供给外部的接口函数
     */
    public function listPortals() {
        $form = $this->_get_query_form();
        if($this->model->assert_form($form,'listPortals'))
        {
            if($form['showPageTool']) {
                $data = $this->model->listPortals(true, $form['auth_mode'], true);
            } else {
                $data = $this->model->listPortals(false, $form['auth_mode'], true);
            }
            $this->_change_data($data,'_list_portal_map');
            $ret['data'] =& $data;
            $ret['total'] = $this->model->num_total();
            $this->log->flush($ret);
        }
		$this->log->flush();

    }

    public function _list_portal_map(&$record = array())
    {
        if (empty($record)) {
            return array();
        }
        if(isset($record['type']))
            $record['type'] = $this->model->type2json($record['type']);
        else
            $record['type'] = '';
        if($record['is_default'])
            $record['name'] = __($record['name']);

    }

    public function createFallstream()
    {
        $this->_reject_slave_wac_opr();
        $form = $this->_get_query_form();
        if($this->model->assert_form($form,'createFallScreen'))
        {
            //$type = $this->model->type2proto($form['type']);
            $ret = $this->model->createFallScreen($form['type']);
            $this->log->flush();
        }
        $this->log->flush();
    }

    public function updateFallstream()
    {
        $form = $this->_get_query_form();
        if($this->model->assert_form($form,'updateFallstream'))
        {
            //$type = $this->model->type2proto($form['type']);
            $ret = $this->model->updateFallstream($form['type']);
            $this->log->flush();
        }
        $this->log->flush();
    }
    
    /**
     * 获取引用详情
     */
    public function cited() {
        $form = $this->_get_query_form();

        if ($this->model->assert_form($form, 'cited')) //表单断言
        {
            $rs = $this->model->cited_detail($form['data']['id']); //查询
            $ret['data'] = $rs;
            $this->log->flush($ret);

        } else {
            $this->log->flush();
        }
    }
    
    /**
     * 获取跳转页面的呢日哦那个
     */
    public function list_redirect_page() {
        $form = $this->_get_query_form();

        if ($this->model->assert_form($form, 'list_redirect_page')) //表单断言
        {
            $rs = $this->model->list_redirect_page($form['portal']['id']); //查询
            $ret['data'] = $rs;
            $this->log->flush($ret);

        } else {
            $this->log->flush();
        }
    }

    
    /**
     * 翻译 portal_text 字段
     * 
     * @param        $record        string        记录
     */
    protected function _translate_portal_text($record) {
        if (isset($record['portal_text']) && is_array($record['portal_text'])) 
        {
            $val = & $record['portal_text'];
            if (isset($val['account_tab_title']) && 
                in_array($val['account_tab_title'], array('账号认证', 'User Account'))) 
            {
                $val['account_tab_title'] = __('账号认证2');
            }
            if (isset($val['account_tab_desc']) && 
                in_array($val['account_tab_desc'], array('内部员工，使用账号密码方式登录', 'I am staff. Use account to access WLAN.'))) 
            {
                $val['account_tab_desc'] = __('内部员工，使用账号密码方式登录');
            }
            if (isset($val['sms_tab_title']) && 
                in_array($val['sms_tab_title'], array('短信认证', 'SMS'))) 
            {
                $val['sms_tab_title'] = __('短信认证2');
            }
            if (isset($val['sms_tab_desc']) && 
                in_array($val['sms_tab_desc'], array('输入您的手机号码获取验证码', 'Provide phone number and get an SMS PWD.'))) 
            {
                $val['sms_tab_desc'] = __('输入您的手机号码获取验证码');
            }
            if (isset($val['guest_tab_title']) && 
                in_array($val['guest_tab_title'], array('临时账号', 'Guest Account'))) 
            {
                $val['guest_tab_title'] = __('临时账号');
            }
            if (isset($val['guest_tab_desc']) && 
                in_array($val['guest_tab_desc'], array('临时账号，使用账号密码方式登录', 'I am guest. Use account to access WLAN.'))) 
            {
                $val['guest_tab_desc'] = __('临时账号，使用账号密码方式登录');
            }
            if (isset($val['submit_btn_text']) && 
                in_array($val['submit_btn_text'], array('登录', 'Log In'))) 
            {
                $val['submit_btn_text'] = __('登录');
            }
            if (isset($val['get_sms_code_btn_text']) && 
                in_array($val['get_sms_code_btn_text'], array('获取验证码', 'Get SMS PWD'))) 
            {
                $val['get_sms_code_btn_text'] = __('获取验证码');
            }
            $company_type = get_company_type();
            if($company_type===COMPANY_ABROAD||$company_type===COMPANY_SUNDRAY)//新公司
            {
                if (isset($val['copyright']) && 
                    in_array($val['copyright'], array('© 2013-2015  信锐网科版权所有','© 2013-2015  版权所有', 'Copyright © 2013-2015 SUNDRAY. All Rights Reserved'))) 
                {
                    $val['copyright'] = ' ';//__('© 2013-2015  信锐网科版权所有');
                }
            }
            else
            {
                if (isset($val['copyright']) && 
                    in_array($val['copyright'], array('© 2013-2015  深信服版权所有','© 2013-2015  版权所有', 'Copyright © 2013-2015 SANGFOR. All Rights Reserved'))) 
                {
                    $val['copyright'] = ' ';//__('© 2013-2015  深信服版权所有');
                }
            }
            
            if (isset($val['qrcode_tab_desc']) && 
                in_array($val['qrcode_tab_desc'], array('二维码认证方法', 'Guest Authentication'))) 
            {
                $val['qrcode_tab_desc'] = __('二维码认证方法');
            }
            if (isset($val['qrcode_tab_info']) && 
                in_array($val['qrcode_tab_info'], array("请让接待您的员工或具有审核权限的其他人员,使用软件(例如:腾讯微信)扫描此二维码进行审核确认,通过后即可上网。", "Use any QR code reader on a qualified receptionist's smart device to scan the QR code."))) 
            {
                $val['qrcode_tab_info'] = __('请让接待您的员工或具有审核权限的其他人员,使用软件(例如:腾讯微信)扫描此二维码进行审核确认,通过后即可上网。');
            }
            if (isset($val['qrcode_tab_title']) && 
                in_array($val['qrcode_tab_title'], array('二维码认证', 'QR Code'))) 
            {
                $val['qrcode_tab_title'] = __('二维码认证');
            }
            if (isset($val['wechat_tab_title']) && 
                in_array($val['wechat_tab_title'], array('微信认证', 'WeChat authentication','WeChat'))) 
            {
                $val['wechat_tab_title'] = __('微信认证');
            }
            if (isset($val['wechat_tab_desc']) && 
                in_array($val['wechat_tab_desc'], array('欢迎使用微信认证', 'Welcome to use WeChat authentication')))
            {
                $val['wechat_tab_desc'] = __('欢迎使用微信认证');
            }
            if (isset($val['nouser_tab_title']) && 
                in_array($val['nouser_tab_title'], array('免用户认证', 'Open WiFi Access')))
            {
                $val['nouser_tab_title'] = __('免用户认证');
            }        
            if (isset($val['nouser_tab_desc']) && 
                in_array($val['nouser_tab_desc'], array('请点击登录按钮直接上网','请点击下面的按钮直接上网。', 'Please click on the button below to get access to WLAN.'))) 
            {
                $val['nouser_tab_desc'] = __('请点击下面的按钮直接上网。');
            }              
        }
        return $record;
    }


    public function uploadTpl()
    {
        $form = $this->_get_query_form();
        if($this->model->assert_form($form,'uploadTpl'))
        {
            $ret = $this->model->uploadTpl();
            if(isset($ret['confirmMsg']))
            {
                $ret['success'] = false;
                $this->log->flush($ret);
            }elseif(isset($ret['upgrade']))
            {
                $rs = array($ret['data']);
                $this->_change_data($rs,'_detail_fallstream');
                $form['data'] = $rs[0];
                if($this->model->assert_form($form,'uploadTpl'))
                {
                    $type = $this->model->type2json($ret['data']['type']);
                    $rs = $this->model->updateFallstream($type);
                    $this->log->flush();
                }
            }else
                $this->log->flush();
        }
        $this->log->flush();
    }

    // --------------------------------------------------------------------
    
    /**
     *提供给升级替换的接口
     *
     */
    public function upgrade() 
    {
        if ($this->_is_cli()) //shell调用
        {
            $result = $this->model->update_change();
            if($result) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            else 
            {
                echo 'error'; //失败，啥都不输出
                exit(1);
            }
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }
    // --------------------------------------------------------------------
    
    /**
     *提供给升级替换的接口——1.5sp2添加微信相关标签
     *
     */
    public function upgrade_wechat_tpl() 
    {
        if ($this->_is_cli()) //shell调用
        {
            $result = $this->model->update_change_portal_wechat();
            if($result) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            else 
            {
                echo 'error'; //失败，啥都不输出
                exit(1);
            }
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }
    // --------------------------------------------------------------------
    
    /**
     *提供给备机切换portal页面中英文的接口
     *
     */
    public function portal_switch() 
    {
        if ($this->_is_cli() && is_slave_wac()) //shell调用
        {
            $result = $this->model->portal_switch();
            if($result) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            else 
            {
                echo 'error'; //失败，啥都不输出
                exit(1);
            }
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }

    // --------------------------------------------------------------------
    
    /**
     * portal页面中英文切换接口，把所有内置模板的portal都重新生成一遍
     * 内部用接口
     */
    public function switch_portal() 
    {
        if (!$this->_is_cli())
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
        $form = array(
            'keyword' => null,
            'start' => 0,
            'limit' => 1000,
            'dir' => 'asc',
            'sort' => 'name',
        );
        if ($this->model->assert_form($form, 'index')) //表单断言
        {
            $rs = $this->model->index(); //查询
            $ret['data'] = $this->_process_query_result($rs); //对查询结果进行处理
            $this->_change_data($ret['data']);
            $form = array();
            unset($this->model);
            foreach ($ret['data'] as $record)
            {
                if ('custom' == $record['type'] || '' == $record['type'])
                {
                    continue;
                }
                $form1 = array('data' => array('id' => $record['id']), 'type' => $record['type']);
                unset($model);
                $model = new \Obj_auth_Model();
                if ($model->assert_form($form1, 'detail')) //表单断言
                {
                    $rs = array($model->detail()); //详细查询
                    $this->_change_data($rs, '_detail_map');
                    $form2['data'] = $rs[0];
                    $form2['type'] = $record['type'];
                    unset($model);
                    $model = new \Obj_auth_Model();
                    if ($model->assert_form($form2, 'update')) //表单断言
                    {
                        $rs = $model->update(true, true);
                    }
                    $form2 = array();
                }
                $form1 = array();
            }
        }
    }
    // --------------------------------------------------------------------
    
    /**
     *提供给升级替换的接口——从默认模版复制的portal页面从1.5x版本升级到1.6做平滑升级
     *
     */
    public function upgrade_copy_tpl() 
    {
        if ($this->_is_cli()) //shell调用
        {
            $result = $this->model->update_change_for_copy_portal();
            if($result) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            else 
            {
                echo 'error'; //失败，啥都不输出
                exit(1);
            }
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }

    // --------------------------------------------------------------------
    
    /**
     * 提供给升级替换的接口——免认证平滑升级
     *
     */
    public function upgrade_nouser_auth() 
    {
        if ($this->_is_cli()) //shell调用
        {
            $recordset = $this->model->get_recordset();
            if (empty($recordset)) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            foreach ($recordset as $key=>$record) 
            {
                switch($record['type']) {
                    case \wns\portal_tpl_type_e::COPY_DEFAULT_TPL:
                        break;
                    case \wns\portal_tpl_type_e::AD_AUTH_PAGE_TPL:
                        break;
                    case \wns\portal_tpl_type_e::DISCLAIMER_AUTH_PAGE_TPL:
                        break;
                    case \wns\portal_tpl_type_e::AD_AND_DISCLAIMER_PAGE_TPL:
                        break;
                    default :
                        unset($recordset[$key]);
                        break;
                }
            }
            $this->_change_data($recordset, '_detail_map');
            foreach ($recordset as $key=>$val) 
            {
                if (isset($val['portalText'])) 
                {
                    $val['portalText']['nouserTab']['nouserTabTitle'] = __('免用户认证');
                    $val['portalText']['nouserTab']['nouserTabDesc'] = __('请点击下面的按钮直接上网。');
                }
                $form['data'] = $val;
                $form['type'] = $val['type'];
                if ($this->model->assert_form($form, 'update')) //表单断言
                {
                    $this->model->update(true, true);
                    if ($this->log->has_error()) 
                    {
                        echo 'error'; //失败，啥都不输出
                        exit(1);
                    }
                }
            }
            echo 'ok'; //成功，输出个ok
            exit(0);
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }

    // --------------------------------------------------------------------
    
    /**
     * 用户在升级时强制重新编辑所有用户可编辑的模板和页面
     * 提供给升级替换修改过的默认模版——平滑升级
     *
     */
    public function upgrade_updatedef_tpl() 
    {
        if ($this->_is_cli()) //shell调用
        {
            $recordset = $this->model->get_recordset();
            if (empty($recordset)) 
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            $sort_full_ext = $this->model->get_type_by_sort('fullscreen_ext');
            $config_type = $this->model->get_user_config_portal_type();
            foreach ($recordset as $key=>$record)
            {
                if(in_array($record['type'],$config_type))
                {
                    continue;
                }
                unset($recordset[$key]);
            }


            foreach ($recordset as $key=>$val) 
            {//按分类去升级
                echo $val['name'];
                if(in_array($val['type'],$sort_full_ext))
                {//3.2R3
                    $form = array();
                    $record = [$val];
                    $this->_change_data($record,'_detail_fallstream');
                    $form['data'] = array_shift($record);
                    $form['type'] = $this->model->type2json($val['type']);
                    if($this->model->assert_form($form,'updateFallstream'))
                    {
                        $this->model->updateFallstream($form['type']);
                        if ($this->log->has_error())
                        {
                            echo 'error'; //失败，啥都不输出
                            exit(1);
                        }
                    }
                }else{//<=wns3.2
                    $form = array();
                    $record = [$val];
                    $this->_change_data($record,'_detail_map');
                    $form['data'] = array_shift($record);
                    $form['type'] = $this->model->type2json($val['type']);
                    if ($this->model->assert_form($form, 'update')) //表单断言
                    {
                        $this->model->update(true, true);
                    	if ($this->log->has_error()) 
                        {
                            echo 'error'; //失败，啥都不输出
                            exit(1);
                        }
                    }
                }


            }
            echo 'ok'; //成功，输出个ok
            exit(0);
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }

    /**
     *切换所有认证页面的默认语言
     */
    public function upgrade_tpl_for_lang()
    {

        if ($this->_is_cli()) //shell调用
        {
            $lang = $_REQUEST['lang'];
            $this->model->update_tpl_default_lang($lang);
            $this->upgrade_updatedef_tpl();
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }

    }

    /**
     * 将非自定义的模版更新到最新
     */
    public function upgrade_latest_tpl()
    {
        if ($this->_is_cli()) //shell调用
        {
            $recordset = $this->model->get_recordset();
            if (empty($recordset))
            {
                echo 'ok'; //成功，输出个ok
                exit(0);
            }
            //非自定义模版和自动工具数据集
            $_change_ok_list = array(
                    \wns\portal_tpl_type_e::COPY_DEFAULT_TPL => true,
                    \wns\portal_tpl_type_e::AD_AUTH_PAGE_TPL => true,
                    \wns\portal_tpl_type_e::DISCLAIMER_AUTH_PAGE_TPL => true,
                    \wns\portal_tpl_type_e::AD_AND_DISCLAIMER_PAGE_TPL => true,
                    //\wns\portal_tpl_type_e::AD_FULL_SCREEN_PAGE_TPL => true,
            );
            foreach ($recordset as $key=>$record)
            {
                //自定义模版和自动wlan模版过滤掉
                if(isset($_change_ok_list[$record['type']]))
                {
                    continue;
                }
                unset($recordset[$key]);
            }
            $this->_change_data($recordset, '_detail_map');
            foreach ($recordset as $key=>$val)
            {
                $form['data'] = $val;
                $form['type'] = $val['type'];
                if ($this->model->assert_form($form, 'update')) //表单断言
                {
                    $this->model->update(true, true);
                    if ($this->log->has_error())
                    {
                        echo 'error'; //失败，啥都不输出
                        exit(1);
                    }
                }
            }
            echo 'ok'; //成功，输出个ok
            exit(0);
        }
        else
        {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: '. sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }

    // --------------------------------------------------------------------
    
    /**
     * for定制，修改了portal模板，需要页面提交保存才能生效，这里仿造这一操作
     * --hyz
     */
    public function for_submit() {
        $rs = $this->model->get_fullad(); //查询为全屏模板的记录
        foreach ($rs as $key => $val) {
            $val = array($val);
            $this->_change_data($val, '_detail_map');
            $this->model->assert_form($val[0], 'for_submit');
            $this->model->update();
        }
        echo "ok";
    }

    public function create_tpl_zip()
    {
        if ($this->_is_cli()) //shell调用
        {
            $result = $this->model->create_tpl_zip();
            $form = array();
            $record = [$result];
            $this->_change_data($record,'_detail_fallstream');
            $form['data'] = array_shift($record);
            $form['type'] = $this->model->type2json($result['type']);
            if($this->model->assert_form($form,'updateFallstream'))
            {
                $this->model->createFallScreen($form['type'],false);
                if ($this->log->has_error())
                {
                    echo $this->log->get_error_string();
                    echo 'error'; //失败，啥都不输出
                    exit(1);
                }
                $this->model->get_tpl_zip();
            }

            echo 'ok'; //成功，输出个ok
            exit(0);

        } else {
            $this->_unset_auth();
            header('Location:' . LOGIN_URL); //回登录页
            if (is_development()) header('X-FILE-LINE: ' . sprintf('%s:%d', basename(__FILE__), __LINE__));
            exit;
        }
    }
    
}
