<?php
if (!defined('BASEPATH'))
    exit('No direct script access allowed');
/**
 * FILE:系统状态-集中监控
 * AUTHOR :zhangjie
 * DATE:2015-04-20
 */
class central_model extends SF_Model {

    /**
     * protobuf object
     */
    protected $_proto = null;
    /**
     * config file
     */
    protected $_conf = '';
    protected $_scinfo_conf = '';


    /**
     * 最大ID号
     */
    protected $_max_id = 0;

    /**
     * max
     */
    protected $_limit_branch = null;
    protected $_limit_sync_cfg = null; //支持一次最多支持同步多少个分支的配置 或 支持一次最多加载多少个分支的AP组配置

    /**
     * message object
     */
    protected $_message = null;
    protected $_wac_role = null;
    protected $_sc_info = null;
    protected $_sc_info_msg = null;
    protected $_old_index = null;
    protected $_old_record = null;
    protected $_used_idset = null;
    protected $_new_idset = null;
    protected $_delete_ids = null;
    CONST MAC_ID_CNT = 8191;
    CONST SC_SYNCLOG_CNT = 50; //同步日志最多显示前50条

    const SC_SYNCLOG = '/var/log/sc.log';//同步日志保存的文件名前缀
    /**
     * 分支接入点配置的基础目录
     */
    const BRANCH_FOLDER = '/wns/etc/config/wac/branch/';
    /**
     * 分支接入点配置的镜像基础目录
     */
    const BRANCH_MIRROR_FOLDER = '/wns/etc_mirror/wns/etc/config/wac/branch/';

    /**
     * 集中管理分支接入点配置备份目录
     */
    const MGMT_AP_BAK = '/wns/data/webui/sc_bak/';
    /**
     * 临时秘钥生成程序
     */
    const CMD_PWDENC = '/wns/sbin/scpwdenc';
    const HA_BRANCH_FILE = '/wns/etc/config/wac/branch_chg_ha.xml';
    const TRANSFER_APCONF_TASK_DIR = '/tmp/ap_data/';
    const TRANSFER_APCONF_RESULT_DIR = '/tmp/ap_data_err/';

    const PREVIEW_LIMIT = 5;

    public $_import_exceed = false;
    public $_import_exist = 0;
    protected $_mgmt_child_role = null;
    /**
     * construct
     */
    public function __construct() {
        parent::__construct();
        $this->_limit_branch = $this->get_branch_uplimit();
        $this->_limit_sync_cfg = 25; /*服务支持当前页25个分支同步*/
        require_once(APPPATH.'third_party/wns_phpext/wns_ipc.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_branch_network.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_sc_info.php');
        require_once(APPPATH.'third_party/proto/msg/webui_msg_wac_sc.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_sc.php');
        require_once(APPPATH.'third_party/proto/msg/msg_tcpproxy.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_tcpproxy.php');
        require_once(APPPATH.'third_party/proto/msg/msgid_ac_realinfo.php');
        require_once(APPPATH.'third_party/proto/conf/sc_common.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_ap.php');
        require_once(APPPATH . 'third_party/proto/conf/dir_chg_ha.php');
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wired_policy.php');

        $this->_conf = $this->configs['conf_folder'].'wns_cfg_branch_network.xml';
        $this->_scinfo_conf = $this->configs['conf_folder'].'wns_cfg_sc_info.xml';
        $this->_deposit_conf = $this->configs['conf_folder'].'wns_cfg_wl_ap_deposit.xml';
        $this->_center_branch_info = $this->configs['conf_folder'].'center_branch_list.xml';
        $this->_global_pwd_conf = $this->configs['conf_folder'].'sc_global_release_pwd.xml';
        $this->load->model('system_management/admin_account/admin_account_model');
        $this->pwdenc_model = $this->admin_account_model;
        build_dir(dirname($this->_conf));
        build_dir(dirname($this->_scinfo_conf));
        build_dir(self::BRANCH_FOLDER);
        $this->_new_idset = [];
        $this->db = get_db_handle('ap');
        $this->_read();
    }

    /**
     * 表单断言
     *
     * @param		$form		array		表单数据
     * @param		$action		string		表单动作(index,query,create,delete,update)
     */
    public function assert_form(array & $form, $action) {
        //供子类定制，在model层对表单进行特殊处理
        parent::assert_form($form, $action);
        switch ($action) {
            case 'index':
                break;
            case 'create':
                break;
            case 'update':
                break;
            case 'delete':
                if (!is_array($this->_args['data'])) {
                    $this->_args['data'] = array($this->_args['data']);
                }
                break;
            case 'import':
                break;
            default:
                break;
        }
        $this->log->add('debug', array(
            'opr'    => isset($_REQUEST['opr']) ? $_REQUEST['opr'] : $this->router->fetch_method(),
            'fields' => array_values($this->CI->_list_map()),
            'action' => $action,
            'args'   => $this->_args));
        return true;
    }

    /**
     * 获取列表信息
     */
    protected function get_branch_uplimit()
    {
        $this->load->model('system_maintenance/sn/sn_model');
        return $this->sn_model->get_sn_branch_num();
    }

    /**
     * 获取控制器角色
     */
    public function get_wac_role() {
        return $this->_wac_role;
    }

    public function get_wac_mgmt_role()
    {
        return $this->_mgmt_child_role;
    }

    /**
     * 获取列表信息
     */
    public function index() {
        //供子类定制
        $this->get_real_branch_list();
        $this->_replace();
        $this->_filter(); //搜索
        $this->_sort(); //排序
        $arr = array_paging($this->_recordset, $this->_args['start'], $this->_args['limit']); //分页
        return $arr;
    }

    public function get_real_branch_list()
    {
        $realbranchinfo = $auth_center_map = array();
        if(is_center_wac())
        {
            $replyobj = new \webui_msg\branch_basic_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $ret = php_wns_ipc_to_self(\wns\module_id_e::REALINFO_SRV, 0,
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_REQ, "",
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_RESP, 3);
            $obj = $bincodec->decode($replyobj, $ret['buf']);
            if($obj === null) {
                bug(__('获取数据失败，请检查服务是否已运行'));
            }

            $result = $obj->getBranchBasicInfo();
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
            foreach ($result as $key => $val) {
                $val = $arrcodec->encode($val); //转成数组
                $realbranchinfo[$val['account_id']] = $val;
            }
            $auth_center_map = $this->get_auth_type_branch_map();
        }
        foreach($this->_recordset as $key => $record)
        {
            unset($this->_recordset[$key]['pwd']); //密码不返回给列表

            if(isset($realbranchinfo[$record['id']]))
            {
                if($realbranchinfo[$record['id']]['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE &&
                isset($auth_center_map[$record['id']]) && $auth_center_map[$record['id']] === \wns\branch_auth_style::CENTER_AUTH)
                {
                    $realbranchinfo[$record['id']]['auth_style'] = \wns\branch_auth_style::CENTER_AUTH;
                }
                $this->_recordset[$key] =  $this->_recordset[$key] + $realbranchinfo[$record['id']];
            }
        }
        return;
    }

    /**
     * 获取在线的集中管理列表信息
     */
    public function get_online_mgmt_branch_list() {
        $this->get_real_branch_list();
        $ret = array();
        $centrer = array('id' => 0, 'name' => __('中心控制器')); //先包含中心端
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) && $record['monitor_stat']
                && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
            {
                $ret[] = array('id' => $record['id'], 'name' => $record['name'],);
            }
        }
        $ret = $this->check_branch_data($ret);
        if($this->check_center_right())
            $ret['tree'] = array_merge([$centrer],$ret['tree']);
        return $ret['tree'];
    }

    /**
     * 获取在线的集中管理列表信息
     */
    public function get_online_mgmt_branch_map() {
        $this->get_real_branch_list();
        $ret[0] = true; //中心控制器
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) && $record['monitor_stat']
                && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
            {
                $ret[$record['id']] = true;
            }
        }
        return $ret;
    }

    /**
     * 获取集中管理/维护列表信息
     */
    public function get_mgmt_branch_list() {
        $this->get_real_branch_list();
        $ret = array();
        $ret[] = array('id' => 0, 'name' => __('中心控制器')); //先包含中心端
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) &&
                ($record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                 $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
            {
                $ret[$record['id']] = array('id' => $record['id'], 'name' => $record['name'],);
            }
        }
        return $ret;
    }

    public function check_is_mgmt_branch($ids)
    {
        static $mgmt_branch = null;
        static $map = array();
        if(is_null($mgmt_branch))
        {
            $mgmt_branch = $this->get_mgmt_branch_list();
            $map = array();
            foreach($this->_recordset as $key=>$val)
            {
                $map[$val['id']] = $val['name'];
            }
        }
        $ids = is_array($ids)?$ids:array($ids);
        foreach($ids as $id)
        {
            if($id == CENTER_ID)
                continue;
            if(isset($mgmt_branch[$id]))
                continue;
            bug(__('分支不是管理/维护模式',$map[$id]));
        }
        return true;
    }


    /**
     * 过滤出有权限的分支list
     * @param $list
     * @param string $field
     * @return array
     */
    public function filter_branch_list($list,$field='id')
    {
        $list = array_usort($list, 'name', 'asc', 'pinyin_sort_cmp');
        $list = sort_apgroup($list, 'id');
        if (is_super_role())
        {
            return $list;
        }
        $right_ids = $this->get_right_branch_data();
        if($right_ids['all_branch']){
            return $list;
        }
        foreach($list as $key => $row)
        {
            if(isset($right_ids['data'][$row[$field]]))
            {
                continue;
            }
            unset($list[$key]);
        }
        if(empty($list))
            $list = array();
        else
            $list = array_values($list);

        return $list;
    }

    /**
     * 获取接入点管理页面
     */
    public function get_show_branch_list() {
        $this->get_real_branch_list();
        $ret = array();
        $ret[] = array('id' => 0, 'name' => __('中心控制器'),'group_id'=>1); //先包含中心端
        $addbranch = array(); //追加在后面显示：曾经加入过集中管理而现在切换成了集中监控 或者 独立WAC的分支
        foreach($this->_recordset as $key => $record)
        {
            if(isset($record['mode']) && $record['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
            {
                $ret[] = array('id' => $record['id'], 'name' => $record['name'],'group_id'=>$record['group_id']);
            }
            else
            {
                $sn_file = self::BRANCH_FOLDER.$record['id'].'/wns_cfg_sn_info.xml';
                if(file_exists($sn_file)) //存在sn_info配置，代表曾经加入过集中管理
                {
                    $addbranch[] = array('id' => $record['id'], 'name' => $record['name'],'group_id'=>$record['group_id']);
                }
            }
        }
        if(!empty($addbranch))
        {
            $ret = array_merge($ret, $addbranch);
        }
        return $ret;
    }

    /**
     * 通过分支所在分组，获取可配置的分支
     * @return array
     */
    public function listConfigBranchByPID()
    {
        $this->_recordset = $this->get_show_branch_list();
        $this->_filter();
        $arr = array_paging($this->_recordset, $this->_args['start'], $this->_args['limit']); //分页
        return $arr;
    }


    /**
     * 获取列表信息
     */
    public function listbranch() {

        $replyobj = new \webui_msg\branch_stat_info_resp();
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::BRANCH_INFO_C, '',
            \wns\webui_msgid_sc_e::BRANCH_INFO_R, 3);
        if($ret === null || $ret === -2)
        {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        $retdata = $this->_conv_msgObj_to_array($obj);
        $branch_version = exec('cat /app/appversion | head -n1');
        $retdata['version'] = $branch_version;
//        $retdata['center_addr'] = $this->_sc_info['join_sc']['center_addr']; //后台返回这个字段
        $result = array('data' => $this->get_ui_branch_status($retdata));
        return $result;
    }

    /**
     * 获取WAC的SC信息
     */
    public function list_sc_info()
    {
        $ret = $this->_sc_info;
        if(isset($ret['join_sc']))
        {
            $ret['join_sc']['branch_mode'] = $this->branch_mode2ui($ret['join_sc']['branch_mode'],$ret['join_sc']['auth_style']);
        }
        $ret['wac_mode'] = $this->wac_role2ui( $ret['wac_mode']);
        return $ret;
    }

    /**
     * 控制器角色UI显示转换
     */
    protected function wac_role2ui($role)
    {
        $uirole = "";
        switch($role)
        {
            case \wns\wac_role_e::INDEPENDENT_E :
                $uimode = INDEPENDENT;
                break;
            case \wns\wac_role_e::CENTER_E :
                $uimode = CENTER;
                break;
            case \wns\wac_role_e::BRANCH_E :
                $uimode = BRANCH;
                break;
            default:
                break;
        }
        return $uimode;
    }
    /**
     * 分支模式UI显示转换
     */
    public function branch_mode2ui($mode,$auth_style=\wns\branch_auth_style::DISTBT_AUTH)
    {
        $uimode = "";
        switch($mode)
        {
            case \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE :
                $uimode = 'monitor';
                break;
            case \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE :
                $uimode = 'mgmt';
                if($auth_style === \wns\branch_auth_style::CENTER_AUTH)
                    $uimode = 'centerauth';
                break;
            case \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE :
                $uimode = 'mainten';
                break;
            default:
                break;
        }
        return $uimode;
    }

    protected function _assert_branch_status($status)
    {
        switch($status)
        {
            case \wns\branch_status_type_e::WEB_ONLINE :
                $msg = __("分支在线");
                break;
            case \wns\branch_status_type_e::WEB_OFFLINE :
                $msg = __("分支离线");
                break;
            case \wns\branch_status_type_e::WEB_NONE_ACCOUNT :
                $msg = __("分支不存在");
                break;
            case \wns\branch_status_type_e::WEB_PASSWORD_ERR :
                $msg = __("分支密码错误");

                break;
            case \wns\branch_status_type_e::WEB_ACCOUNT_LOGIN :
                $msg = __("分支使用的账号已登录，请使用其他账号接入");
                break;
            case \wns\branch_status_type_e::WEB_DIFF_VERSION :
                $msg = __("分支与中心端版本不一致");
                break;
            case \wns\branch_status_type_e::WEB_EXCEED_LIMIT :
                $msg = __("分支个数超出限制");
                break;
            case \wns\branch_status_type_e::WEB_NETWORK_OFF :
                $msg = __("与中心端网络不通");
                break;
            case \wns\branch_status_type_e::WEB_CONNECT_FAIL :
                $msg = __("网络正常，分支连接中心端失败");
                break;
            case \wns\branch_status_type_e::WEB_KB_PACKAGE :
                $msg = __("与中心端kb包不一致，不允许加入集中管理");
                break;
            default :
                $msg = "";
                break;
        }
        return $msg;
    }
    /**
     * 分支状态UI显示转换
     */
    protected function get_ui_branch_status($retdata) {
        $retdata['mode'] = $this->branch_mode2ui($retdata['mode'],$retdata['auth_style']);
        $retdata['msg'] = $this->_assert_branch_status($retdata['status']);
        if($retdata['status'] === \wns\branch_status_type_e::WEB_ONLINE)
            $retdata['status'] = true;
        else
            $retdata['status'] = false;
        
        $retdata['last_conn_time'] = date("Y-m-d H:i:s",$retdata['last_conn_time']);
        return $retdata;
    }

    /**
     * 返回记录总数
     */
    public function gettotalcnt() {
        return $this->_recordset_total;
    }

    /**
     * 详细记录
     *
     */
    public function detail() {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if (isset($this->_args['data']['id']) && $val['id'] === $this->_args['data']['id']) {
                $val['pwd'] = $this->pwdenc_model->pwd_dencypt($val['pwd']);
                if(isset($val['group_id']))
                {
                    $this->load->model('sys_configure/central_monitor/central_area_model');
                    $val['path']['id'] = $val['group_id'];
                    $val['path']['text'] =
                        $this->central_area_model->get_path_by_grpid($val['group_id']);
                }
                return $val;
            }
        }
        bug(__('record_unexist'));
    }

    /**
     * 排序
     *
     */
    protected function _sort() {

        if(!isset($this->_args['sort']) || $this->_args['sort'] !== 'status') {
            $this->_args['sort'] = 'name';
        }
        $this->_recordset = array_usort($this->_recordset, $this->_args['sort'], $this->_args['dir'], 'pinyin_sort_cmp');
    }

    /**
     * 替换成前端识别的数据
     *
     * @return		array
     */
    protected function _replace() {
        foreach($this->_recordset as &$data)
        {
            if(!isset($data['monitor_stat']))
            {
                $data['status'] = -1;
            }else{
                $data['status'] = $data['monitor_stat'];
            }
        }
    }

    /**
     * 过滤$this->_recordset
     *
     */
    protected function _filter() {
        //供子类定制
        $this->load->model('sys_configure/central_monitor/central_area_model');
        if(isset($this->_args['filter']['group_id']))
        {
            $this->_args['group_id'] = $this->_args['filter']['group_id'];
        }
        if(isset($this->_args['group_id']) && $this->_args['group_id'] !== '')
        {
            $filter_grps = $branch = array();
            $this->central_area_model->get_right_grp(
                array(intval($this->_args['group_id'])), $filter_grps, $branch);
        }

        if(isset($this->_args['filter']['beg']) && $this->_args['filter']['end'])
        {
            $begintime = strtotime($this->_args['filter']['beg'].' 00:00:00');
            $endtime = strtotime($this->_args['filter']['end'].' 23:59:59');
        }
        foreach($this->_recordset as $key => $val)
        {
            if(isset($filter_grps) && !isset($filter_grps[$val['group_id']]))
            {
                unset($this->_recordset[$key]);
            }
            if(isset($this->_args['filter']['status']) && $this->_args['filter']['status'] != -2) //-2代表所有
            {
                if(intval($this->_args['filter']['status']) !== $val['status'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($this->_args['filter']['mode']) && $this->_args['filter']['mode'] != -1) // -1代表所有
            {
                if(!isset($val['mode']))
                {
                    unset($this->_recordset[$key]);
                }
                else{
                    $filter_mode = intval($this->_args['filter']['mode']);
                    $mode = $val['mode'];
                    if(in_array($filter_mode, [4,5]) && $mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                    {
                        $mode = (isset($val['auth_style']) && $val['auth_style']===\wns\branch_auth_style::CENTER_AUTH)?4:5; //前端mode=4代表集中认证，5代表分布式认证
                    }
                    if($filter_mode !== $mode)
                    {
                        unset($this->_recordset[$key]);
                    }
                }
            }
            if(isset($this->_args['filter']['unactive']) && $this->_args['filter']['unactive'] != -1) // -1代表所有
            {
				if(!isset($val['unactive_ap_cnt']) || (bool)$this->_args['filter']['unactive'] !== (bool)$val['unactive_ap_cnt'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($this->_args['filter']['offline']) && $this->_args['filter']['offline'] != -1) // -1代表所有
            {
                if(!isset($val['offline_ap_cnt']) || (bool)$this->_args['filter']['offline'] !== (bool)$val['offline_ap_cnt'])
                {
                    unset($this->_recordset[$key]);
                }
            }
            if(isset($begintime))
            {
                if(!isset($val['last_update_time']) ||
                    $val['last_update_time'] < $begintime || $val['last_update_time'] > $endtime )
                {
                    unset($this->_recordset[$key]);
                }
            }
        }
        $this->_recordset = array_values($this->_recordset);
        if(isset($this->_args['filter']['name']))
        {
            array_query($this->_recordset, array('name'), $this->_args['filter']['name']);
        }
        elseif(isset($this->_args['keyword']))
        {
            array_query($this->_recordset, array('name'), $this->_args['keyword']);
        }
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
        $this->_recordset = $this->filter_branch_list($this->_recordset);
        $this->_recordset_total = count($this->_recordset);

    }

    /**
     * 删除，最好支持批量删除
     *
     * @param		$write		bool		是否写入磁盘
     */

    public function delete($write = true) {
        //供子类定制
        $need_write = false;
        $delete_ids = array();
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $this->_args['data'] = $this->_recordset;
            $this->_recordset = $bak_data;
        }
        foreach ($this->_args['data'] as $key => $val) {
            $id = intval($val['id']);
            $record = array('id' => $id);
            if (!$this->is_id_exist($record, $index)) {
                continue;
            }
            if(!$write) //更新记录时，暂时删除记录、不写入磁盘，不需要检查引用关系和写日志
            {
                unset($this->_recordset[$index]);
                return true;
            }
            if (!is_null($index)) {
                unset($this->_recordset[$index]);
                $sucarr[] = $val['account'];
                $delete_ids[] = $val['id'];
                $need_write = true;
            }
        }
        if ($need_write && $write)
        {
            $rs = parent::delete($write);
        }

        $data = array(
            'succList' => $sucarr,
//            'errorList' => $citearr,
        );
        $del_deposit = array();
        foreach($delete_ids as $branch_id)
        {
            //分支删除时，需要删除该分支配置的文件夹
            $branch_dir = self::BRANCH_FOLDER . $branch_id;
            if (is_dir($branch_dir))
            {
                $this->exec("rm -rf ".$branch_dir, $output, $code);
            }
            $branch_mirror_dir = self::BRANCH_MIRROR_FOLDER . $branch_id;
            if (is_dir($branch_mirror_dir))
            {
                $this->exec("rm -rf ".$branch_mirror_dir, $output, $code);
            }
            //判断分支是否为托管分支，如果是托管分支，需要取消托管
            $deposit_branch = $this->get_deposit_branch_map();
            if(isset($deposit_branch[$branch_id]))
            {
                $del_deposit[$branch_id] = true;
            }
            $this->_delete_ids[$branch_id] = $branch_id;
        }
        //删除分支账号时删除引用文件
        exec('rm -f /wns/etc/config/wac/*.json');
        //删除掉分支的AP组、AP配置
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
        $this->wl_apgroup_model->delete_record_by_branchid($delete_ids);
        $this->load->model("wireless_configure/wireless_ap/wl_ap_model");
        $this->wl_ap_model->delete_record_by_branchid($delete_ids);
        if(!empty($del_deposit))
        {
            $bak_action = $this->_action; //因为_delete_deposit_cfg中会修改$this->_action，所以这里
            $this->_delete_deposit_cfg($deposit_branch, $del_deposit);
            $this->_action = $bak_action;
        }
        else
        {
            $this->update_config_after_deposit_change(null); //只处理删除关联配置
        }
        if(!empty($delete_ids))
        {
            $this->load->model('runstat_configure/spotted_map_model');
            $this->spotted_map_model->delete_entity_by_branch($delete_ids);
        }
        if($this->_action !== __FUNCTION__)
            return true;
        if(!empty($sucarr)) {
            $limit = config_item('logobj_limit');
            if(count($sucarr) > $limit) {
                $sucarr = array_slice($sucarr,0,$limit);
                $string = implode(',',$sucarr).'...';
            } else {
                $string = implode(',',$sucarr);
            }
            $msg = __('删除分支账号').$string;
            parent::addLog('controller_cluster',$msg,true);
        }
        return $data;
    }

    /**
     * 查看同步日志
     */
    public function get_sc_synclog()
    {
        if($this->_wac_role === CENTER)
        {
            if(isset($this->_args['data']['id']))
                $log_pre = '['. $this->_args['data']['id']. ']';
            else
                return array(__('无日志'));
        }
        else
            $log_pre = '[0]';

        $arr = array();
        if(!$fp = fopen(self::SC_SYNCLOG, 'r'))
        {
            return __('无日志');
        }
        $pos=-2;
        $eof="";
        $n = self::SC_SYNCLOG_CNT;
        while($n > 0)
        {
            while($eof != "\n")
            {
                if(!fseek($fp, $pos, SEEK_END))
                {
                    $eof=fgetc($fp);
                    $pos--;
                }
                else
                {
                    break;
                }
            }
            $str_tmp = fgets($fp);
            if(!$str_tmp)
            {
                break;
            }
            if(stripos($str_tmp, $log_pre) !== false)
            {
                $arr[] = substr($str_tmp, strlen($log_pre));//$str_tmp去除一下前缀
                //$arr[] = $str_tmp;
                $n--;
            }
            $eof="";
        }
        if(empty($arr))
        {
            return array(__('无日志'));
        }
        return $arr;
    }

    /**
     * 提取主键
     */
    protected function _get_id($arr) {
    }

    /**
     * 修改
     *
     * @param		$write		bool		是否写入磁盘
     */
    public function update($write = true) {
        //供子类定制
        $record = array();
        $record['id'] = intval($this->_args['data']['id']);
        if (!$this->is_id_exist($record, $index))
        {
            bug(__('record_unexist'));
        }
        $this->_old_index = $index;
        $this->_old_record = $record_bak = $this->_recordset[$index];
        $args_bak = $this->_args;
        $this->_args = array('data' => array($this->_args['data']));
        if ($this->delete(false))
        {
            $this->_args = $args_bak;
            try
            {
                $rs = $this->create($write);
                if ($this->log->has_error() || !$rs) //重建失败保留原来的记录
                {
                    $this->_recordset[$index] = $record_bak;
                }
            }
            catch (Exception $e)
            {
                $this->_recordset[$index] = $record_bak;
                throw $e;
            }
            if (__FUNCTION__ === $this->_action)
            {
                if ($rs)
                {
                    parent::addLog('controller_cluster',__('编辑分支账号 %s',$this->_old_record['account']),true);
                }
                else
                {
                    parent::addLog('controller_cluster',__('编辑分支账号 %s',$this->_old_record['account']),false);
                }
            }
            return $rs;
        }
        else
        {
            bug(__('unable_delete_record'));
        }
    }

    /**
     * 判断记录是否存在
     *
     * @param		$record		mixed		记录
     * @param		$index		mixed		冲突记录的索引
     * @return					bool
     */
    public function is_name_exist($record, &$index = null) {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if ($val['name'] === $record['name']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }

    /**
     * 判断账号是否存在
     *
     * @param		$record		mixed		记录
     * @param		$index		mixed		冲突记录的索引
     * @return					bool
     */
    public function is_account_exist($record, &$index = null) {
        //供子类定制
        foreach ($this->_recordset as $key => $val) {
            if ($val['account'] === $record['account']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }

    public function is_id_exist($record, &$index = null) {
        
        if($this->_wac_role === CENTER && $record['id'] === CENTER_ID){
            return true;
        }
        foreach ($this->_recordset as $key => $val) {
            if ($val['id'] === $record['id']) {
                $index = $key;
                return true;
            }
        }
        return false;
    }
    /**
     * 读取，从配置文件读取原始数据到$this->_recordset
     */
    protected function _read() {
        //供子类定制
        $msg = new \wns\sc_info_t();
        if (!$this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf)) {
            /*if (!is_empty($rs))*/ {
                bug(__('unexpected_config'));
            }
        }

        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = $arrcodec->encode($msg); //转成数组
        $this->_sc_info_msg = $msg;
        $wac_role = $this->_sc_info['wac_mode'];
        if($wac_role === \wns\wac_role_e::CENTER_E) //中心端支持查看分支状态列表
        {
            $this->_read_branchs();
            $this->_wac_role = CENTER;
        }
        elseif($wac_role === \wns\wac_role_e::BRANCH_E)
        {
            if($this->_sc_info['join_sc']['branch_mode']=== \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
                $this->_wac_role = MONITOR_BRANCH;
            else{//维护模式是特殊的管理模式
                if($this->_sc_info['join_sc']['branch_mode']=== \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
                {
                    if(isset($this->_sc_info['join_sc']['auth_style']) && $this->_sc_info['join_sc']['auth_style'] === \wns\branch_auth_style::CENTER_AUTH)
                    {
                        $this->_mgmt_child_role = MGMT_CENTERAUTH;
                    }else{
                        $this->_mgmt_child_role = MGMT_DISTRIBUTEAUTH;
                    }
                }else{
                    $this->_mgmt_child_role = MGMT_MAINTENANCE;
                }

                $this->_wac_role = MGMT_BRANCH;
            }

        }
        else
        {
            $this->_wac_role = INDEPENDENT;
        }
    }

    /**
     * 获取分支列表
     */
    public function get_branch_list()
    {
        $ret = array();
        foreach($this->_recordset as $val)
        {
            $ret[$val['id']] = $val;
        }
        $ret[0] = array('name' => __('中心控制器'),'id'=>CENTER_ID);
        return $ret;
    }

    /**
     * 获取所有分支的树结构
     * @return array
     */
    public function get_branch_tree()
    {
        $branchs = $this->get_branch_list();
        $tree = array();
        foreach($branchs as $branch)
        {
            $node = array();
            $node['id'] = $branch['id'];
            $node['branch_id'] = $branch['id'];
            $node['name'] = $branch['name'];
            $node['type'] = 'branch';
            $node['leaf'] = true;
            $node['checked'] = false;
            $node['children'] = array();
            if($node['id'] === 0)
            {
                $node['deletable'] = false;
            }
            $tree[] = $node;
        }
        $tree = $this->check_branch_data($tree);
        return $tree;
    }

    /**
     * 读取，从配置文件读取原始数据到$this->_recordset
     */
    protected function _read_branchs()
    {
        $msgs = new \wns\BranchTable();
        if (!$this->_read_protobuf_from_xml($msgs->descriptor()->getName(), $msgs, $this->_conf)) {
            /*if (!is_empty($rs))*/ {
                bug(__('unexpected_config'));
            }
        }
        $rs = $msgs->getBranchList();
        $this->_max_id = $msgs->getMaxId();
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        foreach ($rs as $key => $val) {
            $rs[$key] = $arrcodec->encode($val); //转成数组
            $this->_read_callback($rs[$key]);
            if(!isset($rs[$key]['group_id']))
                $rs[$key]['group_id'] = 0;
            $this->_used_idset[$rs[$key]['id']] = $rs[$key]['id']; //已经使用了的id集合
        }
        $this->_recordset = $rs;
        $this->_recordset_total = count($this->_recordset);
    }
    /**
     * 将$this->_recordset写入磁盘或数据库
     *
     * @return		bool
     */
    protected function _write() {
        //供子类定制
        $msgs = new \wns\BranchTable();
        $msgs->setMaxId($this->_max_id);
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        ksort($this->_recordset);
        foreach ($this->_recordset as $key => $val) {
            $this->_write_callback($val);
            $val = $arrcodec->decode(new \wns\Branch(), $val); //转成对象
            $msgs->addBranchList($val);
        }
        $rs = $this->_write_protobuf_to_xml($msgs->descriptor()->getName(), $msgs, $this->_conf);

        if (!$rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_conf, false); //第二个参数表示此次配置更改是否有风险
        return true;
    }

    /**
     * _read方法的回调函数
     *
     * @param		$record		array		记录
     */
    protected function _read_callback(array & $record) {

    }

    /**
     * _write方法的回调函数
     *
     * @param		$record		array		记录
     */
    protected function _write_callback(array & $record) {
        //供子类定制

    }

    /**
     * 新增
     *
     * @param		$write		bool		是否写入磁盘
     */
    public function create($write = true) {
        if('update' !== $this->_action)
        {
            if ($this->uplimit()) {
                if($this->_limit_branch === 0)
                    bug(__("集中管理序列号未开启。"));
                else
                    $this->log->add('error', __('branch_exceed_uplimit', $this->_limit_branch));
                if ('import' === $this->_action)
                {
                    $this->_import_exceed = true;
                }
                return false;
            }
        }
        $record = array('name' => $this->_args['data']['name'],);
        if ($this->is_name_exist($record)) {
            if ('import' === $this->_action)
            {
                ++$this->_import_exist;
            }
            bug(__('该分支名已存在！'));
        }
        $record = array('account' => $this->_args['data']['account'],);
        if ($this->is_account_exist($record)) {
            bug(__('该分支账号已存在！'));
        }
        $record = $this->_args['data'];
        //update的时候也会修改密码
        if($record['pwd'] !== "")
        {
            $record['pwd'] = $this->pwdenc_model->pwdenc($record['pwd']);
        }
        if ('update' !== $this->_action) //新增
        {
            $record['id'] =  $this->get_loop_record_id();
            $this->_recordset[] = $record;
            $this->check_update_area_data($record['group_id']);
        }
        else
        {
            $record['id'] = $this->_args['data']['id'];
            $this->_recordset[$this->_old_index] = $record;
            if($record['group_id'] != $this->_old_record['group_id'])
            {
                $this->check_update_area_data($record['group_id']);
            }
        }
        //先给分支创建AP配置和目录，创建好后再创建分支。
        if (__FUNCTION__ === $this->_action || 'import' === $this->_action)
        {
            if (__FUNCTION__ === $this->_action)  //导入统一到import接口处理
            {
                $ret = $this->create_branch_conf();
                if($ret === false)
                {
                    if(!$this->log->has_error())
                    {
                        bug(__("获取数据失败，请检查服务是否已运行"));
                    }
                    return false;
                }
            }
            //分支新增时创建文件夹，由后台来维护。
//            分支创建成功，需要新增一个分支配置的文件夹，并加入默认的AP组配置
//            $branch_dir = self::BRANCH_FOLDER . $record['id'];
//            if (is_dir($branch_dir))
//            {
//                exec("rm -rf ".$branch_dir, $output, $code);
//            }
//            if(build_dir($branch_dir) === false)
//            {
//                build_dir($branch_dir); //创建失败，重建一次
//            }
            if('import' === $this->_action)
                return true;
        }
        $rs = parent::create($write);
        if (!$rs) {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_conf));
            if (__FUNCTION__ === $this->_action)
            {
                parent::addLog('controller_cluster',__('添加分支账号 %s',$record['account']),false);
                bug($str);
            }
            return false;
        }
        if (__FUNCTION__ === $this->_action) {
            parent::addLog('controller_cluster', __('添加分支账号 %s', $record['account']), true);
        }
        return true;

    }

    public function create_branch_conf($branch_id = null)
    {
        $addcount = count($this->_new_idset);
        $start_time=get_run_time();
        if(is_null($branch_id))
        {
            $addids = implode("\n", $this->_new_idset);
            $transfer_notify = sprintf("%s_1_-1_%d_%d",  $start_time, $addcount, $addcount);
            $notify_file = self::TRANSFER_APCONF_TASK_DIR.$transfer_notify;
            $rs = touch($notify_file);
            file_put_contents($notify_file, $addids);
        }
        else{
            $transfer_notify = sprintf("%s_%d_%d_#_#",  $start_time, 1, $branch_id);
            $rs = touch( self::TRANSFER_APCONF_TASK_DIR.$transfer_notify);
        }
        $timecount = 120; //等两分钟
        $result_file = self::TRANSFER_APCONF_RESULT_DIR.$transfer_notify;
        $errorcnt = 5;
        while($timecount--)
        {
            sleep(1);
            if(is_file($result_file))
            {
                $ret = file_get_contents($result_file);
                if($ret === '')
                    continue;
                $ret = explode("\n", $ret);
                //错误码0：成功；2：AP组个数超过上限；3：AP个数超过上限；
                //1：mac冲突，在第二行开始每行显示："显示冲突mac;冲突mac所在分支id;ap名称"
                if(isset($ret[0]))
                {
                    switch($ret[0])
                    {
                        case '0':
                            return true;
                        case '1':
                            $branch_raw = $this->get_branch_list();
                            foreach($ret as $key => $val)
                            {
                                if($key === 0) //错误码行跳过
                                    continue;
                                $val = trim($val);
                                if($val === '')
                                    continue;
                                $val = explode(';', $val);
                                if(!isset($val[2]))
                                    return false;
                                if(!$errorcnt--) //最多记录5条错误提示
                                    break;
                                $branch_id = intval(trim($val[1]));
                                if ($branch_id == 0) { //branch_id = 0
                                    $this->log->add('error', __('MAC地址 {0} 已被中心端的接入点：{1}占用', trim($val[0]), trim($val[2]))); //MAC已被名称占用
                                } else {
                                    $this->log->add('error', __('MAC地址 {0} 已被分支：{1}的接入点：{2}占用', trim($val[0]),
                                        @$branch_raw[$branch_id]['name'], trim($val[2]))); //MAC已被名称占用
                                }
                            }
                            break;
                        case '2':
                            $this->log->add('error', __('中心控制器（包括分支）AP组（区域）总个数超过上限 %d。', $this->get_uplimit('limit_ap_group')));
                            break;
                        case '3':
                            $this->log->add('error', __('中心控制器（包括分支）AP总个数超过上限 %d。', $this->get_uplimit('limit_ap_local')));
                            break;
                        case '4':
                            $this->log->add('error', __('分支加载AP配置出现内部错误，请联系技术支持人员。'));
                            break;
                        case '-1':
                            return false;
                    }
                }
                return false;
            }
        }
        return false;
    }

    /**
     * 最大记录数
     */
    protected function uplimit() {
        $count = count($this->_recordset) + 1;
        if ($count > $this->_limit_branch) {
            return true;
        }
        return false;
    }


    /**
     * 判断id是否存在的
     */
    public function has_exists($id) {
        $id = intval($id);
        foreach($this->_recordset as $record) {
            if($record['id'] === $id) {
                return true;
            }
        }
        return false;
    }

    protected function branch_has_apgrp($branch_id)
    {
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
        return $this->wl_apgroup_model->branch_has_userdef_conf($branch_id);
    }

    /**
     * 加载AP组配置
     */
    public function load_apgrp_config()
    {
        $sendobj = new \webui_msg\center_req_msg();
        $branch_id = $this->_args['branch_id'];
        if(intval($branch_id) === 0)
        {
            bug(__("中心端无法远程加载配置"));
        }
        $branch_raw = $this->get_branch_list();
        if(!$this->branch_has_apgrp($branch_id))
        {
            bug(__("中心端已经给分支：%s配置了接入点（分组），请先删除，再加载该分支的AP配置", $branch_raw[$branch_id]['name']));
        }
        $sendobj->setAccountId($branch_id); //目前服务只支持一次加载1个分支AP组配置
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\center_rsp_msg();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::LOAD_AP_GRP_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::LOAD_AP_GRP_CFG_R, 10);
        if($ret === -2)
        {
            bug(__("与服务通讯超时"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getRet();
        if($ret === \webui_msg\msg_result_e::FAULED)
        {
            bug(__('服务执行出错'));
        }
        elseif($ret === \webui_msg\msg_result_e::BRANCH_NOT_ONLINE)
        {
            bug(__('该分支离线或不处于管理模式，无法加载AP配置'));
        }
        elseif($ret === \webui_msg\msg_result_e::BAK_FILE_NOT_EXIST)
        {
            bug(__('该分支的AP备份配置不存在'));
        }

        $ret = $this->create_branch_conf($branch_id);
        if($ret === false)
        {
            if(!$this->log->has_error())
            {
                bug(__("获取数据失败，请检查服务是否已运行"));
            }
            return false;
        }
        parent::addLog('controller_cluster',__('加载分支%s 的接入点配置', $branch_raw[$branch_id]['name']),true);
        return true;
    }

    /**
     * 立即同步配置
     */
    public function load_sync_config()
    {
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $branchs = $this->_recordset;
            $msg = __('立即同步所有分支的配置');
            $this->_recordset = $bak_data;
        }
        else
        {
            $branchs = $this->_args['data'];
        }
//        if(count($branchs) > $this->_limit_sync_cfg) //与ysq沟通，不做同步分支个数限制
//        {
//            bug(__("最多支持%d个分支同时同步配置", $this->_limit_sync_cfg));
//        }
        $objs = [];
        $sendobj = new \webui_msg\center_req_msgs();
        foreach($branchs as $key => $val)
        {
            $sendobj->addAccountId($val['id']);
            $objs[] = $val['account'];
        }
        if(!isset($msg))
        {
            $msg = __('立即同步以下分支的配置：%s', and_so_on_limit($objs));
        }
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        $ret1 = php_wns_ipc_to_self(\wns\module_id_e::AUTH_MOD_WAC_USERORG, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        parent::addLog('controller_cluster',$msg,true);
        return true;
    }


    /**
     * 立即同步本地用户配置
     */
    public function load_sync_localusr_config()
    {
        $sendobj = new \webui_msg\center_req_msgs();
        $sendobj->setIsAll(true);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_CONFIG_SRVD, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        $ret1 = php_wns_ipc_to_self(\wns\module_id_e::AUTH_MOD_WAC_USERORG, 0,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_C, $req,
            \wns\msgid_sc_config_svd_e::SYNC_CFG_R, 0);
        return true;
    }

    private function update_ref_wlan($mode, $branchmap)
    {
        $center = ($mode === \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE);
        $distr = ($mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE);
        if(!$center && !$distr)
            return true;
        //无线网络或接入点有线认证
        $confs = [$this->configs['conf_folder'] . 'wns_cfg_wl_wlan_ui.xml',
            $this->configs['conf_folder'] . 'wns_cfg_wl_ap_wired_ui.xml'];
        foreach($confs as $conf)
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wlan_list');
            $needwrite = false;
            foreach($rs['wlan_list'] as $key => &$wlan)
            {
                if(($center && $wlan['wlan_basic']['filter_type'] === \wns\wlan_center_auth_method_e::WLAN_AUTH_DISTR)
                    || ($distr && $wlan['wlan_basic']['filter_type'] === \wns\wlan_center_auth_method_e::WLAN_AUTH_CENTER))
                    //已经配置了分布式认证网点ssid、切换成集中认证 || 已经配置了集中认证网点ssid、切换成分布式认证
                {
                    if(!empty($wlan['branch_list']))
                    {
                        foreach($wlan['branch_list'] as $i => $branch)
                        {
                            if(isset($branchmap[$branch['branch_id']]))
                            {
                                if(!empty($wlan['ap_id']) && !empty($branch['ap_id']))
                                    $wlan['ap_id'] = array_diff($wlan['ap_id'], $branch['ap_id']);
                                if(!empty($wlan['group_id']) && !empty($branch['group_id']))
                                    $wlan['group_id'] = array_diff($wlan['group_id'], $branch['group_id']);
                                if($branch['is_all_grp']) //防止写了该网点的所有区域的id
                                {
                                    static $branch_root_apgid = null; //所有分支的“所有区域”的id
                                    if(is_null($branch_root_apgid))
                                    {
                                        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");
                                        $branch_root_apgid = $this->wl_apgroup_model->get_branch_root_id();
                                    }
                                    if(isset($branch_root_apgid[$branch['branch_id']]))
                                    {
                                        $wlan['group_id'] = array_diff($wlan['group_id'], [$branch_root_apgid[$branch['branch_id']]]);
                                    }
                                }
                                unset($wlan['branch_list'][$i]);
                                $needwrite = true;
                            }
                        }
                    }
                }
            }
            if($needwrite)
            {
                array_to_xml_file('wns.cfg_wlan_list', $rs, $conf);
            }
            unset($rs);
        }
        return true;
    }

    /**
     * 切换分支模式
     */
    public function switch_branch_mode()
    {
        $modemsg = '';
        if($this->_args['mode'] === 'mgmt') //按照当前模式获取切换的模式
        {
            $modemsg = __('分布式管理模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
        }
        elseif($this->_args['mode'] === 'monitor') //按照当前模式获取切换的模式
        {
            $modemsg = __('监控模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;

        }elseif($this->_args['mode'] === 'center_auth')
        {
            $modemsg = __('集中认证管理模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE;
        }
        else
        {
            $modemsg = __('维护模式');
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE;
        }
        $sendobj = new \webui_msg\center_change_branch_mode_req();
        if(isset($this->_args['selectall']) && $this->_args['selectall'])
        {
            $bak_data = $this->_recordset;
            $this->_filter();
            $branchs = $this->_recordset;
            $msg = __('切换所有分支的工作模式为 %s', $modemsg);
            $this->_recordset = $bak_data;
        }
        else
        {
            $branchs = $this->_args['rs'];
        }
        $objs = [];
        $branchmap = [];
        foreach($branchs as $key => $val)
        {
            if($mode === \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE) //切换成集中认证模式
            {
                if(!$this->check_conf_legal($val['id']))
                {
                    bug(__('切换失败！分支：%s 配置了“在当前控制器上做Portal认证”类型的有线认证策略，不允许切换成集中认证模式！', $val['name']));
                }
            }
            $sendobj->addAccountId($val['id']);//中心端需要提供是切换哪个分支的模式
            $branchmap[intval($val['id'])] = true;
            $objs[] = $val['name'];
        }
        $this->update_ref_wlan($mode, $branchmap);
        if(!isset($msg))
        {
            $msg = __('切换以下分支的工作模式为{0}：{1}', $modemsg, and_so_on_limit($objs));
        }
        $sendobj->setMode($mode);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\center_change_branch_mode_resp();
        //切换通知到sc_proxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHANGE_BRANCH_MODE_C, $req,
            \wns\webui_msgid_sc_e::CHANGE_BRANCH_MODE_R, 3);
        /*
        if($ret === -2)
        {
            bug(__("与服务通讯超时"));
        }
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getChangeRet();
        if($ret !== \webui_msg\change_result_e::CHANGE_SUCCESSED)
        {
            if($ret === \webui_msg\change_result_e::VERSION_DIFF)
            {
                bug(__('中心端和分支的版本不一致，无法切换'));
            }
	    elseif($ret === \webui_msg\change_result_e::KBVERSION_DIFF)
	    {
                bug(__('中心端和分支的KB包版本不一致，无法切换'));
            }
            elseif($ret === \webui_msg\change_result_e::BRANCH_OFFLINE)
            {
                bug(__('分支离线，无法切换模式'));
            }
            else
            {
                bug(__('分支工作模式切换失败'));
            }
            return false;
        }*/
        parent::addLog('controller_cluster',$msg, true);

        return true;
    }

    protected function check_conf_legal($branch_id)
    {
        $branch_folder = '/wns/etc/config/wac/branch/';
        $conf = $branch_folder.$branch_id.'/wns_cfg_wired_policy_ui.xml';
        if(file_exists($conf))
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wired_list');
            if(is_null($rs) || -1 === $rs) {
                bug(__('unexpected_config'));
            }
            if(empty($rs['wired_list']))
            {
                return true;
            }
            foreach($rs['wired_list'] as $val)
            {
                if($val['wired_basic']['portal_sub'] === \wns\wlan_portal_sub_type_e::PORTAL_SUBTYPE_LOCAL_PORTAL)
                {
                    return false;
                }
            }
        }
        return true;
    }

    /**
     * 分支端切换分支模式
     */
    public function switch_self_mode()
    {
        if($this->_sc_info['join_sc']['branch_mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)
        {
            $this->_sc_info['join_sc']['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;
            $wac_role = MONITOR_BRANCH;
        }
        else
        {
            $this->_sc_info['join_sc']['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            $wac_role = MGMT_BRANCH;
        }

        $sendobj = new \webui_msg\branch_change_mode_req();
        $sendobj->setReleasePwd($this->_args['data']['pwd']); //分支端切换模式需要安全密码（与解控密码一致）
        $sendobj->setMode($this->_sc_info['join_sc']['branch_mode']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);

        $replyobj = new \webui_msg\branch_change_mode_resp();
        //切换通知到sc_proxyd模块
        $ret_prxyd = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHANGE_MODE_C, $req,
            \wns\webui_msgid_sc_e::CHANGE_MODE_R, 10);
        $obj = $bincodec->decode($replyobj, $ret_prxyd['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getChangeRet();
        if($ret !== \webui_msg\change_result_e::CHANGE_SUCCESSED)
        {
            if($ret === \webui_msg\change_result_e::VERSION_DIFF)
            {
                bug(__('中心端和分支的版本不一致，无法切换'));
            }
            elseif($ret === \webui_msg\change_result_e::BRANCH_OFFLINE)
            {
                bug(__('分支离线，无法切换模式'));
            }
            else
            {
                bug(__('切换失败，解控密码错误'));
            }
            return false;
        }
        //切换成功，保存配置
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);

        $this->_wac_role = $wac_role;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster',__('切换分支的工作模式'), true);
        return true;
//        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);
//
//        if (!$rs)
//        {
//            $str = __('config_unwritable');
//            $this->log->add('debug', array($str, $this->_scinfo_conf));
//            bug($str);
//        }
//        $this->load->model('php_config_model');
//        $this->php_config_model->add($this->_scinfo_conf);
//        return true;
    }


    /**
     * 中心端切换分支模式、分支端修改配置中的模式——提供给后台调用
     */
    public function modify_sc_mode($mode)
    {
        $mode = intval($mode);
        $sess_wac_role = $this->session->userdata(Runtime_Model::WACROLE); //切换前WAC角色
        $wac_role = MGMT_BRANCH;
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE)//分布式认证
        {
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::DISTBT_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ) //分支端只有管理模式，维护模式认为是特殊的管理模式
        {
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::DISTBT_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_SHUNT_MODE)//集中认证
        {
            $mode = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            $this->_sc_info['join_sc']['auth_style'] = \wns\branch_auth_style::CENTER_AUTH;
        }
        if($mode === \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE)
        {
            $wac_role = MONITOR_BRANCH;
        }
        if (0 !== strcmp($wac_role, $sess_wac_role)) //WAC角色切换
        {
            if($wac_role === MGMT_BRANCH) //切换成集中管理的分支需要备份AP配置
            {
                $this->save_old_ap_config();
                //切换至管理分支时自动设置为使用中心端配置
                $this->load->model("system_management/sys_sms/sys_sms_model");
                $this->sys_sms_model->set_enable_advance_switch();
            }
            if($sess_wac_role === MGMT_BRANCH) //从集中管理的分支切换
            {
                $this->load->model("system_management/sys_sms/sys_sms_model");
                $this->sys_sms_model->set_default_advance_switch();
            }
        }
        $this->_sc_info['join_sc']['branch_mode'] = intval($mode);
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        return true;
    }

    public function get_wac_branch_name()
    {
        if(strstr($this->_wac_role, "branch"))
        {
            $replyobj = new \webui_msg\branch_stat_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
                \wns\webui_msgid_sc_e::BRANCH_INFO_C, '',
                \wns\webui_msgid_sc_e::BRANCH_INFO_R, 3);
            if($ret !== null && $ret !== -2)
            {
                $obj = $bincodec->decode($replyobj, $ret['buf']);
                $retdata = $this->_conv_msgObj_to_array($obj);
                return $retdata['branch_name'];
            }
        }
        return '';
    }

    protected function _check_center_addr($center_addr, $isbak = false)
    {
        if(!isset($center_addr) || $center_addr === '')
            return true;
        $this->load->model('wireless_configure/advance_option/wl_option_model');
        $webagent_url = $this->wl_option_model->get_option('webagent_url');
        $bak_webagent_url = $this->wl_option_model->get_option('webagent_backup');
        if($webagent_url === $center_addr)
        {
            if($isbak)
                bug(__("中心端备地址 配置有误，不允许与系统配置->系统选项->主webAgent配置相同地址。"));
            else
                bug(__("中心端主地址 配置有误，不允许与系统配置->系统选项->主webAgent配置相同地址。"));
        }

        if($bak_webagent_url === $center_addr)
        {
            if($isbak)
                bug(__("中心端备地址 配置有误，不允许与系统配置->系统选项->备webAgent配置相同地址。"));
            else
                bug(__("中心端主地址 配置有误，不允许与系统配置->系统选项->备webAgent配置相同地址。"));
        }
        return true;
    }

    /**
     * 切换控制器角色
     */
    public function switch_wac_role()
    {
        $msg = new \wns\sc_info_t();
        $old_role = $this->session->userdata(Runtime_Model::WACROLE);
        $role = $this->_args['data']['wac_mode'];
        if($role === INDEPENDENT)
        {
            if($old_role === CENTER)
            {
                //中心端退出，需要先清空集中管理分支
                if(!empty($this->_recordset))
                {
                    $old_args = $this->_args;
                    $this->_args['data'] = $this->_recordset;
                    $this->delete();
                    if (is_dir(self::BRANCH_FOLDER))
                    {
                        $this->exec("rm -rf ". self::BRANCH_FOLDER.'*', $output, $code);
                    }
                    $this->_args = $old_args;
                }
            }
            $msg->setWacMode(\wns\wac_role_e::INDEPENDENT_E);
            $opr_log = __("退出集中管理");
        }
        elseif($role === CENTER)
        {
            $msg->setWacMode(\wns\wac_role_e::CENTER_E);
            $opr_log = __("加入集中管理，设备切换成中心端");
            //加入集中管理中心端，首次加入需要设置密码
            $this->set_global_release_pwd();
        }
        else /*分支控制器*/
        {
            $msg->setWacMode(\wns\wac_role_e::BRANCH_E);
            //分支控制器需要输入加入集中管理的信息
            $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
            $sc_info = $this->_args['data']['join_sc'];
            $mode = $sc_info['branch_mode'];
            $this->_check_center_addr($sc_info['center_addr']);
            $this->_check_center_addr(@$sc_info['bakup_center_addr'], true);
            if($mode === 'mgmt'){
                $sc_info['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE;
            }
            elseif($mode === 'monitor'){
                $sc_info['branch_mode'] = \wns\central_mgmt_mode_e::CENTRAL_MONITOR_MODE;
            }
            else
                bug(__("分支不支持切换成该模式"));
            $sc_info['pwd'] = $this->pwdenc_model->pwdenc($sc_info['pwd']);
            $joininfo = $arrcodec->decode(new \wns\join_sc_t(), $sc_info);
            $msg->setJoinSc($joininfo);
            $role = $mode.'_branch';
            $opr_log = __("加入集中管理，设备切换成分支");
        }
        $this->_wac_role = $role;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster', $opr_log, true);
        return true;
//        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);
//
//        if (!$rs)
//        {
//            $str = __('config_unwritable');
//            $this->log->add('debug', array($str, $this->_scinfo_conf));
//            bug($str);
//        }
//
//        $this->load->model('php_config_model');
//        $this->php_config_model->add($this->_scinfo_conf);
//        $this->_wac_role = $role;
//        parent::addLog('controller_cluster', $opr_log, true);
//        return true;
    }

    public function _write_sc_conf()
    {
        $rs = $this->_write_protobuf_to_xml($this->_sc_info_msg->descriptor()->getName(), $this->_sc_info_msg, $this->_scinfo_conf);
        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        return true;
    }
    /**
     * 保存旧的AP配置
     */
    public function save_old_ap_config()
    {
        build_dir(self::MGMT_AP_BAK);
        $cmd = "cp -f /wns/etc/config/wac/wns_cfg_wl_ap.xml ". self::MGMT_AP_BAK;
        $cmd = $cmd. "; cp -f /wns/etc/config/wac/wns_cfg_wl_apgroup.xml ". self::MGMT_AP_BAK;
        exec($cmd, $output, $code);
        $this->exec('/wns/sbin/filesum -m '.self::MGMT_AP_BAK. '*');
        //这里发一次配置更新消息
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        if($code === 0)
            return true;
        bug($output[0]);
    }

    /**
     * 分支修改SC基本信息
     */
    public function modify_sc_info()
    {
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info['join_sc']['center_addr'] = $this->_args['data']['center_addr'];
        $this->_sc_info['join_sc']['bakup_center_addr'] = $this->_args['data']['bakup_center_addr'];
        $this->_check_center_addr($this->_sc_info['join_sc']['center_addr']);
        $this->_check_center_addr(@$this->_sc_info['join_sc']['bakup_center_addr'], true);
        $this->_sc_info['join_sc']['account'] = $this->_args['data']['account'];
        $this->_sc_info['join_sc']['pwd'] = $this->pwdenc_model->pwdenc($this->_args['data']['pwd']);
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_scinfo_conf));
            bug($str);
        }
        $this->save_old_ap_config(); //td50936 编辑分支账号提交时需要重新备份接入点配置

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_scinfo_conf);
        parent::addLog('controller_cluster',__('编辑分支账号'), true);
        return true;
    }
    /**
     * 测试与中心端连通性
     */
    public function test_conn()
    {
        $sendobj = new \webui_msg\branch_check_conn_req();
        $sendobj->setCenterAddr($this->_args['data']['center_addr']);
        $sendobj->setAccount($this->_args['data']['account']);
        $sendobj->setPwd($this->_args['data']['pwd']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_check_conn_resp();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHECK_CONN_C, $req,
            \wns\webui_msgid_sc_e::CHECK_CONN_R, 15);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }
        $ret = $obj->getConnRet();
        switch($ret)
        {
            case \webui_msg\conn_result_e::CONN_SUCCESSED:
                $this->log->add('error', __("%s：连接成功", __('中心端主地址')));
                break;
            case \webui_msg\conn_result_e::CONN_ACCOUNT_NONE:
                $this->log->add('error', __("%s：账号不存在", __('中心端主地址')));
                break;
            case \webui_msg\conn_result_e::CONN_PASSWORD_ERR:
                $this->log->add('error', __("%s：密码错误", __('中心端主地址')));
                break;
            case \webui_msg\conn_result_e::CONN_SLAVE_WAC:
                bug(__("备机不支持集中管理"));
                break;
            case \webui_msg\conn_result_e::CONN_FAILED:
            default:
            $this->log->add('error', __("%s：网络不通,请检查中心端地址（IP、端口等）是否正确", __('中心端主地址')));
                break;
        }
        if(!isset($this->_args['data']['bakup_center_addr']) || $this->_args['data']['bakup_center_addr'] === '')
            return true;
        $sendobj->setCenterAddr($this->_args['data']['bakup_center_addr']);
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_check_conn_resp();
        $ret = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::CHECK_CONN_C, $req,
            \wns\webui_msgid_sc_e::CHECK_CONN_R, 15);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getConnRet();
        switch($ret)
        {
            case \webui_msg\conn_result_e::CONN_SUCCESSED:
                $this->log->add('error', __("%s：连接成功", __('中心端备地址')));
                break;
            case \webui_msg\conn_result_e::CONN_ACCOUNT_NONE:
                $this->log->add('error', __("%s：账号不存在", __('中心端备地址')));
                break;
            case \webui_msg\conn_result_e::CONN_PASSWORD_ERR:
                $this->log->add('error', __("%s：密码错误", __('中心端备地址')));
                break;
            case \webui_msg\conn_result_e::CONN_SLAVE_WAC:
                bug(__("备机不支持集中管理"));
                break;
            case \webui_msg\conn_result_e::CONN_FAILED:
            default:
            $this->log->add('error', __("%s：网络不通,请检查中心端地址（IP、端口等）是否正确", __('中心端备地址')));
                break;
        }
        if($this->log->has_error())
        {
            $this->log->flush();
        }
        return true;
    }

    /**
     * 设置全局解控密码
     */
    public function set_global_release_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $pwd = $this->_args['data']['pwd'];
        if($pwd !== "")
        {
            $pwd = $this->pwdenc_model->pwdenc($pwd);
        }
        $msg->setPwd($pwd);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);

        if (!$rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_global_pwd_conf));
            bug($str);
        }

        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_global_pwd_conf);
        if($this->_action === __FUNCTION__)
        {
            parent::addLog('controller_cluster',__('设置全局解控密码'), true);
        }
        return true;
    }

    public function get_global_release_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $rs = $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);
        $pwd = $this->pwdenc_model->pwd_dencypt($msg->getPwd());
        $ret = array(
            'pwd'=>$pwd,
            'pwd_confirm'=>$pwd,
        );
        return $ret;
    }

	
    /**
     * 设置全局解控密码
     */
    public function need_validate_pwd()
    {
        $msg = new \wns\branch_release_pwd();
        $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, $this->_global_pwd_conf);
		$join_suc = intval($msg->getEverJoinSuc());
		if($join_suc)
		{
			return true; //需要校验密码
		}
        //退出成功，保存配置
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = array('wac_mode' => \wns\wac_role_e::INDEPENDENT_E);
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $this->_wac_role = INDEPENDENT;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster',__('退出集中管理'), true);
		return false;
    }

	
    /**
     * 设置某个分支临时解控密钥
     */
    public function set_single_branch_pwd()
    {
        $gateway = $this->_args['data']['gateway'];
        $pwd = "";
        if($gateway !== "")
        {
            $cmd = sprintf('%s "%s"', static::CMD_PWDENC, escape_pwd($gateway));
            $rs = exec($cmd, $output, $code);
            if (0 === $code)
            {
                $pwd = $rs;
            }
            else
            {
                $this->log->add('debug', array($cmd, $output, $code));
                bug(__('fail_to_encrypt_password'));
            }
        }
        parent::addLog('controller_cluster',__('设置分支临时解控密码'), true);
        return $pwd;
    }

    /**
     * 分支申请解控
     */
    public function branch_get_released()
    {
        $sendobj = new \webui_msg\branch_release_req();

        $sendobj->setReleasePwd($this->_args['data']['pwd']);
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \webui_msg\branch_release_resp();

        //切换通知到sc_proxyd模块
        $ret_prxyd = php_wns_ipc_to_self(\wns\module_id_e::SC_PROXYD, 0,
            \wns\webui_msgid_sc_e::BRANCH_RELEASE_C, $req,
            \wns\webui_msgid_sc_e::BRANCH_RELEASE_R, 10);
        $obj_prxyd = $bincodec->decode($replyobj, $ret_prxyd['buf']);
        if($obj_prxyd === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj_prxyd->getReleaseRet();
        if($ret !== \webui_msg\release_result_e::RELE_SUCCESSED)
        {
            bug(__('解控失败，密码错误'));
            return false;
        }

        //退出成功，保存配置
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $this->_sc_info = array('wac_mode' => \wns\wac_role_e::INDEPENDENT_E);
        $msg = $arrcodec->decode(new \wns\sc_info_t(), $this->_sc_info);
        $this->_wac_role = INDEPENDENT;
        //td44965 切换控制器角色的配置放在切换完再最后保存，防止切换过程中，页面被刷新到首页
        $this->_sc_info_msg = $msg;
        parent::addLog('controller_cluster',__('退出集中管理'), true);
        return true;
//        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, $this->_scinfo_conf);
//
//        if (!$rs)
//        {
//            $str = __('config_unwritable');
//            $this->log->add('debug', array($str, $this->_scinfo_conf));
//            bug($str);
//        }
//        $this->load->model('php_config_model');
//        $this->php_config_model->add($this->_scinfo_conf);
//        $this->_wac_role = INDEPENDENT;
//        parent::addLog('controller_cluster',__('退出集中监控'), true);
//        return true;
    }


    /**
     * 获取分支远程登录信息
     */
    public function get_branch_login_info()
    {
        $sendobj = new \wns\webui_so_req();
        $sendobj->setAccountId($this->_args['data']['id']);
        $record['id'] = intval($this->_args['data']['id']);
        $this->is_id_exist($record, $index);
        $account = '';
        if(!is_null($index))
        {
            $account = $this->_recordset[$index]['account'];
        }
        $sendobj->setDstPort($this->_args['data']['https_port']);
        $is_slave = false;
        if($this->_args['data']['slave_sso_ip'] !== "")
        {
            $sendobj->setDstHostIp($this->_args['data']['slave_sso_ip']);
            $is_slave = true;
        }
        elseif($this->_args['data']['master_sso_ip'] !== "")
            $sendobj->setDstHostIp($this->_args['data']['master_sso_ip']);
        else
            bug(__('参数错误'));
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $req = $bincodec->encode($sendobj);
        $replyobj = new \wns\webui_so_resp();
        //切换通知到tcpproxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::TCP_PROXYD, 0,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_REQ, $req,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_RESP, 3);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            bug(__("获取数据失败，请检查服务是否已运行"));
        }

        $ret = $obj->getResult();
        if(!$ret || $ret->getCode() !== \wns\tcpproxy_error_e::ERROR_SUCCESS)
        {
            $msg = $ret->getMsg();
            bug($msg);
        }
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $rs = $arrcodec->encode($obj); //转成数组

        $this->load->model('system_management/admin_account/admin_account_model');

        $is_super = false;
        $role = $this->session->userdata('gid');
        if (ROLE_SUPER === $role)
        {
            $is_super = true;
        }
        if($is_slave)
        {
            parent::addLog('controller_cluster',__('单点登录分支 %s 的备机。', $account), true);
        }
        else{
            parent::addLog('controller_cluster',__('单点登录分支 %s。', $account), true);
        }
        
        //生成token
        $token = '';
        if(!is_null($index))
        {
            $this->load->library('SF_JWT');
            $info['check'] = md5($this->get_global_release_pwd()['pwd']);
            $token = $this->sf_jwt->encode($info);
        }

        return array('port' => $rs['proxy_port'],'is_super'=>intval($is_super),'token' => $token);
    }


    /**
     * 获取分支远程登录端口 —— 给分支单点登录访问数据中心
     */
    public function get_branch_login_port()
    {
        $bincodec = new \DrSlump\Protobuf\Codec\Binary();
        $replyobj = new \wns\webui_so_resp();
        //切换通知到tcpproxyd模块
        $ret = php_wns_ipc_to_self(\wns\module_id_e::TCP_PROXYD, 0,
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_REQ, '',
            \wns\webui_msgid_so_e::SIGN_ON_BRANCH_RESP, 5);
        $obj = $bincodec->decode($replyobj, $ret['buf']);
        if($obj === null) {
            return false;
        }

        $ret = $obj->getResult();
        if(!$ret || $ret->getCode() !== \wns\tcpproxy_error_e::ERROR_SUCCESS)
        {
            return false;
        }
        $arrcodec = new \DrSlump\Protobuf\Codec\PhpArray();
        $rs = $arrcodec->encode($obj); //转成数组

        return $rs['proxy_port'];
    }



    protected function _delete_deposit_cfg($deposit_branch, $del_deposit)
    {
        $new_deposit_conf = array();
        foreach($deposit_branch as $branch => $val)
        {
            if(isset($del_deposit[$branch]))
            {
                continue;
            }
            $new_deposit_conf[] = array('id' => $branch, 'type' => 'branch', 'path' => null);
        }

        $form['data']['deposit'] = $new_deposit_conf;
        if ($this->assert_form($form, 'deposit_branch_apcfg')) //表单断言
        {
            $this->deposit_branch_apcfg();
        }
    }

    /**
     * 分支托管
     */
    public function deposit_branch_apcfg() {
        $branch_ids = $this->_args['data']['deposit'];
        $f = new \pkg\form\admin_account\APsFieldSet('net', null, __('分支'));

        $f->setDisplayValue(array('net' => $branch_ids));
        $data = $f->getRealValue();
        $deposit = [];
        $deposit_branch_set = [];
        if(isset($data['aps_data']))
        {
            $deposit['deposit_account_id'] = $data['aps_data'];
            $deposit_branch_set = array_flip($data['aps_data']);
        }
        if(isset($data['bgrp_data']))
        {
            $deposit['deposit_grp_id'] = $data['bgrp_data'];
            $this->get_all_branchset_by_bgroup_for_deposit($data['bgrp_data'],$deposit_branch_set);

        }
        $rs = array_to_xml_file('wns.cfg_ap_deposit', $deposit, $this->_deposit_conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_deposit_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_deposit_conf);
        if($this->_action === __FUNCTION__)
            parent::addLog('controller_cluster',__('保存接入点托管配置'),true);
        $this->update_config_after_deposit_change($deposit_branch_set);
        //$this->update_center_auth_deposit(); //wns3.2R4不限制集中认证必须托管
        return true;
    }

    /**
     * 获取网点分组包含的所有集中管理的分支    for deposit
     * @param $bgroup                   托管分组
     * @param $deposit_branch_set       托管分组网点map集合
     */
    public function get_all_branchset_by_bgroup_for_deposit($bgroup,&$deposit_branch_set)
    {

        $this->load->model('sys_configure/central_monitor/central_area_model');
        $allgrpids = [];
        $this->central_area_model->get_all_group_id($bgroup, $allgrpids);
        if(!empty($allgrpids))
        {
            $this->get_real_branch_list();
            foreach($this->_recordset as $val)
            {
                if(isset($allgrpids[$val['group_id']]) && isset($val['mode']) &&
                    ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $deposit_branch_set[$val['id']] = $val['id'];
                }
            }
        }
    }

    //更新集中管理分支
    public function update_center_auth_deposit()
    {
        $center_auth_set = array();
        $this->get_real_branch_list();
        $center_auth = $this->get_auth_type_branch_map();
        foreach($this->_recordset as $val)
        {
            if(isset($val['mode']) &&
                ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                    $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
            {
                if(isset($center_auth[$val['id']]) && ($center_auth[$val['id']] == \wns\branch_auth_style::CENTER_AUTH))
                {
                    $center_auth_set[$val['id']] = $val['id'];
                }
            }

        }
        $rs = $this->modify_center_auth($center_auth_set);
        if(!$rs)
            bug(__('集中认证分支保存失败'));
        return $rs;
    }

    public function get_deposit_info()
    {
        $rs = array_from_xml_file($this->_deposit_conf , 'wns.cfg_ap_deposit');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        $ret = ['bgrp'=>array(),'branch'=>array()];
        if(isset($rs['deposit_grp_id']))
        {
            foreach($rs['deposit_grp_id'] as $val)
            {
                $ret['bgrp'][$val] = $val;
            }
        }
        if(isset($rs['deposit_account_id']))
        {
            foreach($rs['deposit_account_id'] as $val)
            {
                $ret['branch'][$val] = $val;
            }
        }
        return $ret;
    }
    /**
     * 读托管的分支
     */
    public function get_deposit_branch_list() {
        $this->db->select('*')->from('deposit_branch_info');
        $rs = $this->db->get()->result_array();
        $deposit_branch_id = array();
        foreach($rs as $key => $val)
        {
            $id = intval($val['branch_id']);
            $deposit_branch_id[$id] = $id;
        }
        return  $deposit_branch_id;
    }

    /**
     * 读托管的分支
     */
    public function get_deposit_branch_info() {
        $deposit_branch_id = $this->get_deposit_branch_list();
        $branch_raw = $this->get_branch_list();
        $depositlist = array();
        foreach ($deposit_branch_id as $key => $val) {
            $depositlist[$val] = array(
                'id' => $val,
                'name' => $branch_raw[$val]['name'],
            );
        }
        return  $depositlist;
    }

    /**
     * 读托管的分支——键值hash
     */
    public function get_deposit_branch_map() {
        static $ret = null;
        if(is_null($ret))
        {
            $deposit = $this->get_deposit_branch_list();
            $ret = array();
            foreach($deposit as $val)
            {
                $ret[$val] = true;
            }
        }
        return $ret;
    }

    /**
     * 读集中认证的分支
     */
    public function get_center_auth_branch_info() {
        $center_auth_map = $this->get_auth_type_branch_map();
        $branch_raw = $this->get_branch_list();
        $center_auth_list = array();
        foreach ($center_auth_map as $key => $val) {
            if($val === \wns\branch_auth_style::CENTER_AUTH && isset($branch_raw[$key]))
            {
                $center_auth_list[$key] = array(
                    'id' => $key,
                    'name' => $branch_raw[$key]['name'],
                );
            }
        }
        return  $center_auth_list;
    }

    /**
     * 读取分布式认证的分支，wyq
     * @return $distbt_auth_list array 分布式认证的分支数组
     */
    public function get_distbt_auth_branch_info()
    {
        $distbt_auth_map = $this->get_auth_type_branch_map();
        $branch_raw = $this->get_branch_list();
        $distbt_auth_list = array();
        foreach ($distbt_auth_map as $key => $val) {
            if($val === \wns\branch_auth_style::DISTBT_AUTH && isset($branch_raw[$key]))
            {
                $distbt_auth_list[$key] = array(
                    'id' => $key,
                    'name' => $branch_raw[$key]['name'],
                );
            }
        }
        return  $distbt_auth_list;
    }

    /**
     * 获取分支认证方式map
     * @return array
     * @throws Exception
     */
    public function get_auth_type_branch_map()
    {
        $msgs = new \wns\center_branch_list();
        if (!$this->_read_protobuf_from_xml($msgs->descriptor()->getName(), $msgs, $this->_center_branch_info)) {
            bug(__('unexpected_config'));
        }
        $info = array();
        foreach($msgs->getBranchListList() as $val)
        {
            $info[$val->getAccountId()] = $val->getAuthStyle();
        }
        return $info;
    }

    // --------------------------------------------------------------------

    /**
     * 通知双机同步分支AP目录/wns/etc/config/wac/branch/
     *
     * @return		bool
     */
    protected function notify_ha()
    {

        //修改同步文件  让文件夹在双机同步
        $msg = new \wns\dir_chg_ha();
        $this->_read_protobuf_from_xml($msg->descriptor()->getName(), $msg, self::HA_BRANCH_FILE);
        $data = $this->_conv_msgObj_to_array($msg);
        $data['key']=isset($data['key'])?(++$data['key']):1;
        $this->_conv_array_to_msgObj($msg, $data);
        $rs = $this->_write_protobuf_to_xml($msg->descriptor()->getName(), $msg, self::HA_BRANCH_FILE);
    }


    /**
     * 托管分支修改，对应引用的配置也需要同步更新，单个配置列表的修改
     * @param $input_conf_list              待修改配置列表
     * @param $deposit_ids                  最新托管分支id，为null表示不修改托管信息，只处理删除
     * @param $all_index                    对应配置所有接入点的标记字段，比如wlan的all_group
     * @param $grp_index                    对应配置中AP组id的字段，比如wlan的group_id
     * @param string $branch_list_index     对应配置中分支list的字段
     * @param string $bid_index             对应配置中分支id的字段
     * @param string $ball_index            对应配置中分支所有的字段
     * @param string $bgrp_index            对应配置中分支分组的字段
     * @param string $callback              判断单条记录是否要更新的回调函数
     * @return bool
     */
    private function update_one_config(&$input_conf_list, $deposit_ids, $all_index, $grp_index,$branch_list_index='branch_list',$bid_index='branch_id',$ball_index='is_all_grp',$bgrp_index='group_id',$callback='_is_update')
    {
        static $center_apg = null;
        static $branch_root_apgid = null; //所有分支的“所有区域”的id
        $this->load->model("wireless_configure/wireless_ap/wl_apgroup_model");

        if(is_null($center_apg))
        {
            $this->wl_apgroup_model->set_branch_id(0);
            $center_apg = $this->wl_apgroup_model->get_all_apgroups(false);
        }
        if(is_null($branch_root_apgid))
        {
            $branch_root_apgid = $this->wl_apgroup_model->get_branch_root_id();
        }
        //配置列表遍历更新托管分支信息
        foreach($input_conf_list as $key => &$val)
        {
            if($all_index === 'sellpush_all_group') //标记是推广规则
            {
                $all_index = 'all_group';
                $bakval = $val;
                $val = $val['condition']['ap'];
            }
            if(!$this->$callback($val))
            {
                goto BAKUP;
            }
            $add_deposit_grp = array();
            //配置选择了所有中心端接入点，则该配置不需要更新，默认包含了托管分支的AP配置
            if(isset($val[$all_index]) && $val[$all_index])
                goto BAKUP;
            //没有配置分支也不需要处理
            if(!isset($val[$branch_list_index]) || empty($val[$branch_list_index]))
                goto BAKUP;
            //将配置中托管分支的AP组数据加入到$add_deposit_grp
            foreach($val[$branch_list_index] as $bkey => $branch)
            {
                if(isset($deposit_ids) && isset($deposit_ids[$branch[$bid_index]]))
                {
                    if($branch[$ball_index])
                    {
                        $add_deposit_grp[] = $branch_root_apgid[$branch[$bid_index]];
                    }
                    else
                    {
                        $add_deposit_grp = array_merge($add_deposit_grp, $branch[$bgrp_index]);
                    }
                }
                if(isset($this->_delete_ids[$branch[$bid_index]])) //删除分支，这里需要删除配置
                {
                    unset($val[$branch_list_index][$bkey]);
                }
            }
            if(isset($deposit_ids)) //为null时不处理托管，只处理删除分支的情况
            {
                //将中心端的AP组（group_id）中，非中心端的AP组id（旧的托管分支）去掉
                if(isset($val[$grp_index]) && !empty($val[$grp_index]))
                {
                    foreach($val[$grp_index] as $i => $grpid)
                    {
                        if(!isset($center_apg[$grpid])) //不属于中心端自身配置，先unset掉
                        {
                            unset($val[$grp_index][$i]);
                        }
                    }
                }
            }
            //将新的托管分支数据加进来
            if(isset($deposit_ids) && !empty($add_deposit_grp))
            {
                if(!isset($val[$grp_index]))
                {
                    $val[$grp_index] = $add_deposit_grp;
                }
                else
                {
                    $val[$grp_index] = array_merge($val[$grp_index], $add_deposit_grp);
                }
            }
            if(empty($val[$branch_list_index]))
            {
                unset($val[$branch_list_index]);
            }
            if(empty($val[$grp_index]))
            {
                unset($val[$grp_index]);
            }
            BAKUP:
            if(isset($bakval))
            {
                $bakval['condition']['ap'] = $val;
                $val = $bakval;
                $all_index === 'sellpush_all_group';
                unset($bakval);
            }
        }
        return true;
    }

    /**
     * 托管是否更新此记录(默认回调函数，不可删！)
     * @return bool
     */
    protected function _is_update($record)
    {
        if(empty($record) || !is_array($record))
            return false;
        return true;
    }

    /**
     * 检查wlan规则是否是配的ap组
     * @param $record
     * @return bool
     */
    protected function _is_update_wlan_rule($record)
    {
        if(isset($record['attr_type'])
            && $record['attr_type']==\wns\wlan_rule_attr_type_e::ATTR_TYPE_LOCATION
            && $record['attr'] == \pkg\form\wlan\SourceAttrComboBox::LOCAL_AP_GROUP)
        {
            return true;
        }
        return false;
    }

    protected function get_loop_record_id()
    {
        $id = $this->_max_id + 1;
        $recordcnt = count($this->_used_idset);
        if($recordcnt >= self::MAC_ID_CNT)
        {
            bug(__('分支个数不能超过上限:%d。', self::MAC_ID_CNT));
        }
        while(isset($this->_used_idset[$id]) || $id > self::MAC_ID_CNT) //个数达到
        {
            $id++;
            if($id > self::MAC_ID_CNT) //8192后id就回环，id=0保留给中心端用的。
            {
                $id = 1;
            }
        }
        $this->_max_id = $id;
        $this->_new_idset[] = $id;
        $this->_used_idset[$id] = $id;
        return $id;
    }

    /**
     * 托管分支修改，对应引用的配置也需要同步更新
     */
    private function update_config_after_deposit_change($deposit_ids)
    {
        //wlan配置、AP有线认证需要同步更新
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wl_wlan.php');
        $wlan_lan_conf = array(
            '/wns/etc/config/wac/wns_cfg_wl_wlan_ui.xml',
            '/wns/etc/config/wac/wns_cfg_wl_ap_wired_ui.xml'
        );
        foreach($wlan_lan_conf as $conf)
        {
            $rs = array_from_xml_file($conf, 'wns.cfg_wlan_list');
            if (is_null($rs) || -1 === $rs)
            {
                bug(__('unexpected_config'));
            }
            if(!empty($rs['wlan_list']))
            {
                $this->update_one_config($rs['wlan_list'], $deposit_ids, 'all_group', 'group_id');
                foreach($rs['wlan_list'] as &$row)
                {
                    if(isset($row['wlan_permission']['rule_list'])){
                        foreach($row['wlan_permission']['rule_list']  as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }
                    if(isset($row['wlan_guest_auth']['guest_role_rule']['rule_list'])){
                        foreach($row['wlan_guest_auth']['guest_role_rule']['rule_list'] as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }
                    if(isset($row['portal_page_rules']['rule_list'])){
                        foreach($row['portal_page_rules']['rule_list'] as &$attr){
                            if(isset($attr['attr_list']))
                            {
                                $this->update_one_config($attr['attr_list'], $deposit_ids,'rule_value_any', 'value','branch_list','branch_id','rule_value_any', 'value','_is_update_wlan_rule');
                            }
                        }
                    }
                   
                }
            }
            $rs = array_to_xml_file('wns.cfg_wlan_list', $rs, $conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $conf));
                bug($str);
            }
        }
        //四个推广规则配置需要同步更新
        require_once(APPPATH . 'third_party/proto/conf/wns_sell_push.php');
        $sell_push_conf['wns.sell_known_rules'] = '/wns/etc/config/wac/wns_sell_push_known_ui.xml';
        $sell_push_conf['wns.sell_keyword_rules'] = '/wns/etc/config/wac/wns_sell_push_keyword_ui.xml';
        $sell_push_conf['wns.sell_online_rules'] = '/wns/etc/config/wac/wns_sell_push_online_ui.xml';
        $sell_push_conf['wns.sell_unknown_rules'] = '/wns/etc/config/wac/wns_sell_push_unknown_ui.xml';
        foreach($sell_push_conf as $fileflag => $conf)
        {
            $rs = array_from_xml_file($conf, $fileflag);
            if (is_null($rs) || -1 === $rs)
            {
                bug(__('unexpected_config'));
            }
            if(!empty($rs['item']))
            {
                $this->update_one_config($rs['item'], $deposit_ids, 'sellpush_all_group', 'group_id');
            }
            $rs = array_to_xml_file($fileflag, $rs, $conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $conf));
                bug($str);
            }
        }

        //灾备策略域
        require_once(APPPATH . 'third_party/proto/conf/wns_cfg_wl_ap_disaster.php');
        $conf = '/wns/etc/config/wac/wns_cfg_control_disaster_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.cfg_ap_disaster_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['ap_disaster_list']))
        {
            $this->update_one_config($rs['ap_disaster_list'], $deposit_ids, null, 'apg_id');
        }
        $rs = array_to_xml_file('wns.cfg_ap_disaster_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //无线负载域
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_ap_blance_list.php');
        $conf = '/wns/etc/config/wac/wns_cfg_ap_blance_list_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.BlanceList');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['blance_rule']))
        {
            $this->update_one_config($rs['blance_rule'], $deposit_ids, null, 'group_id');
        }
        $rs = array_to_xml_file('wns.BlanceList', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }
        //接入点升级
        require_once(APPPATH.'third_party/proto/conf/ap_upg_mission.php');
        $conf = '/wns/etc/config/wac/ap_upg_mission_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.ap_mission_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['ap_mission_list']))
        {
            $this->update_one_config($rs['ap_mission_list'], $deposit_ids, 'is_all_ap', 'ap_group_list');
        }
        $rs = array_to_xml_file('wns.ap_mission_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //无线射频防护
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_widspolicy.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        $conf = '/wns/etc/config/wac/wns_cfg_widspolicy_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.WidsPolicyList');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['policy']))
        {
            $this->update_one_config($rs['policy'], $deposit_ids, 'all_group', 'group_id');
        }
        $rs = array_to_xml_file('wns.WidsPolicyList', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //接入点dhcp防御
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_trusted_dhcp.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        $conf = '/wns/etc/config/wac/wns_cfg_trusted_dhcp_local_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.trusted_dhcp_t');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['range']))
        {
            $this->update_one_config($rs['range'], $deposit_ids, 'is_all_ap', 'group_id');
        }
        $rs = array_to_xml_file('wns.trusted_dhcp_t', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }

        //接入点网络安全
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_arp_isolate_usr_local.php');
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_wl_common_enum.php');
        require_once(APPPATH.'third_party/proto/conf/sc_common.php');
        $conf = '/wns/etc/config/wac/wns_cfg_arp_isolate_usr_local_ui.xml';
        $rs = array_from_xml_file($conf, 'wns.wns_ap_arp_isolate_usr_t');
        if (is_null($rs) || -1 === $rs)
        {
//            bug(__('unexpected_config'));
        }
        if(!empty($rs['trust_obj']))
        {
            $this->update_one_config($rs['trust_obj'], $deposit_ids, 'is_all_ap', 'group_id');
        }
        $rs = array_to_xml_file('wns.wns_ap_arp_isolate_usr_t', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
//            bug($str);
        }

        //定位服务器 —— 有问题，托管的定位服务器就不处理吧
        require_once(APPPATH.'third_party/proto/conf/wns_cfg_3party_server.php');
        $conf = '/wns/etc/config/wac/sys_open_interface.xml';
        $rs = array_from_xml_file($conf, 'wns.location_server_list');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        if(!empty($rs['srv_info']))
        {
            $this->update_one_config($rs['srv_info'], $deposit_ids, null, 'ap_list');
        }
        $rs = array_to_xml_file('wns.location_server_list', $rs, $conf);
        if (0 !== $rs)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($conf);
    }

    /**
     * 获取列表信息
     */
    public function get_uidebug_data($index) {
        require_once('/wns/webui/php_test_data.php');
        $this->data = get_php2ui_data($index);
        return $this->data;
    }

    public function preview()
    {
        set_time_limit(0);
        clearstatcache();
        $path = $this->_get_upload_file($this->_args['id']);
        $ret = array();
        $size_limit = (50*1024*1024);
        $num = 0;
        if(file_exist($path) && filesize($path) != 0)
        {
            $size =  filesize($path);
            if($size>$size_limit || $size<0 || $size === false ){
                bug(__('导入文件不能超过{0}M',50));
            }            
            $fp = fopen($path,'rb');
            $header = array('name','account','pwd','group');
            $cnt = count($header);
            while($record = mb_fgetcsv($fp))
            {
                if (isset($record[0]) && 0 === strncmp($record[0], '#', 1)) {
                    continue;
                }
                $num++;
                if($num>self::PREVIEW_LIMIT){
                    continue;//
                }                
                if(count($record) !== $cnt)
                {
                    $record = array_pad_slice($record,$cnt,'',$cnt);
                }
                foreach($record as &$value){
                    $value = htmlentities($value); //转义 避免xss攻击
                }                
                $ret[] = array_combine($header,$record);
            }
            fclose($fp);
        }else{
            bug(__('请重新选择上传文件'));
        }
        $ret['total'] = $num;
        return $ret;
    }


    protected function _handle_upload_record(array $record)
    {
        $this->load->model('sys_configure/central_monitor/central_area_model');
        if (is_empty($record['group']))
        {
            $record['group_id'] = $this->central_area_model->get_default_group_id(); //获取默认配置的id
        }
        else //组是否存在
        {
            if (false === $this->Fv->check_text($record['group']))
            {
                bug(__('check_text', __('分支分组')));
            }
            $group_id = $this->central_area_model->auto_create_group($record['group']);
            if ($group_id !== false) {
                $record['group_id'] = $group_id;
            }
        }
        return $record;
    }

    public function _parse_branch(array &$record)
    {
        if(false === $this->Fv->required($record['name']))
        {
            bug(__('required', __('分支名称')));
        }
        if(false === $this->Fv->required($record['account']))
        {
            bug(__('required', __('账号')));
        }
        if(false === $this->Fv->required($record['pwd']))
        {
            bug(__('required', __('密码')));
        }
        if(false === $this->Fv->check_text($record['name']))
        {
            bug(__('check_text', __('分支名称')));
        }

        if(false === $this->Fv->check_account($record['account']))
        {
            bug(__('check_account', __('账号')));
        }
        if(false === $this->Fv->check_sshpwd($record['pwd']))
        {
            bug(__('check_key', __('密码')));
        }
    }

    public function import()
    {
        $path = $this->_get_upload_file($this->_args['id']);
        $recordset_bak = $this->_recordset;
        $errorfilename = 'branch_detail'.date('YmdHis').random_string('numeric',10).'.csv';
        $errorfile = rtrim(config_item('temp_folder'), '/').'/'.$errorfilename;
        if(file_exist($path) && filesize($path) != 0)
        {
            $fp = fopen($path,'rb');
            $efp = fopen($errorfile,'w+');
            $header = array('name','account','pwd','group');
            $cnt = count($header);
            $errnum = config_item('errmsg_limit');
            $num = $line = $sucess = $error =0;
            $begin = $this->_max_id + 1;
            while($record = mb_fgetcsv($fp))
            {
                try
                {
                    ++$line;
                    if (isset($record[0]) && 0 === strncmp($record[0], '#', 1))
                    {
                        continue;
                    }
                    ++$num;
                    if(count($record) !== $cnt)
                    {
                        $record = array_pad_slice($record,$cnt,'',$cnt);
                    }
                    $form['data'] = array_combine($header, $record);
                    $form['data'] = $this->_handle_upload_record($form['data']);
                    $this->_parse_branch($form['data']);
                    $this->_args = $form;
                    $rs = $this->create(false);
                    if ($this->_import_exceed)
                    {
                        ++$error;
                        fputcsv($efp,array('#'.__('branch_exceed_uplimit', $this->_limit_branch)));
                        $remain = $this->_limit_branch - count($recordset_bak);
                        if ($remain > 0)
                        {
                            fputcsv($efp, array('#'.__('最多只能导入 {0} 个。', $remain)));
                        }
                        break;
                    }
                    ++$sucess;

                }
                catch(Exception $e)
                {
                    $errmsg = __('error_occur', $line, $e->getMessage());
                    ++$error;
                    array_push($record,$errmsg);
                    fputcsv($efp,$record);
                }


            }
            fclose($fp);
            fclose($efp);
            delete_file($path);

            if ($this->_import_exceed || 0!==$error)
            {
                //delete_file($path);
                $this->log->set_message('error',array());
                if (__FUNCTION__ === $this->_action)
                {
                    $this->addLog('controller_cluster', __('导入分支'), false);
                }
                $this->change_file_encode_shell($errorfile);
                $this->log->add('inform',__('user_import_detail',0,$error,$this->_import_exist));
                return array('path'=>$errorfilename);
            }else{
                if($sucess > 0)
                {
                    $ret = $this->create_branch_conf();
                    if($ret === false)
                    {
                        $this->addLog('controller_cluster', __('导入分支'), false);
                        if(!$this->log->has_error())
                        {
                            bug(__("获取数据失败，请检查服务是否已运行"));
                        }
                        return false;
                    }
                }
                $rs = $this->central_area_model->write();
                $rs = $this->_write();
                if (__FUNCTION__ === $this->_action)
                {
                    if($rs)
                    {
                        $this->addLog('controller_cluster', __('导入分支'), true);
                    }else{
                        $this->addLog('controller_cluster', __('导入分支'), false);
                    }
                }
                return $rs;
            }

        }else{
            bug(__('请重新选择上传文件'));
        }
    }

    public function export()
    {
        set_time_limit(0);
        $this->load->helper('download');
        $name = 'BranchList'.date('Y-m-d',time()).'.csv';
        $file = rtrim(config_item('temp_folder'), '/').'/'.$name;
        $header = array('#'.__('分支名称'),__('账号'),__('密码'),__('分支分组'));
        $fp = fopen($file,'w+');
        fputcsv($fp,$header);
        $this->load->model('sys_configure/central_monitor/central_area_model');
        $area_map = $this->central_area_model->get_grpid_to_group_map();
        foreach($this->_recordset as $record)
        {
            unset($record['id']);
            $record['pwd'] = $this->pwdenc_model->pwd_dencypt($record['pwd']);
            $record['group_id'] = $area_map[$record['group_id']]['name'];
            fputcsv($fp,$record);
        }
        fclose($fp);
        $this->change_file_encode_shell($file);
        force_download($name,$file);
        parent::addLog('controller_cluster',__('导出分支'),true);
        @unlink($file);
        return true;

    }

    /**
     * 获取分支对应中心端连接信息
     * @return array
     */
    public function get_join_sc_info()
    {
        $infor = array();
        $sc = isset($this->_sc_info['join_sc'])?$this->_sc_info['join_sc']:array();
        if(empty($sc))
        {
            $infor = array(
                'account'=>'',
                'pwd'=>'',
                'center_addr'=>'',
                'bak_center_addr'=>'',
            );
        }else{
            $infor = array(
                'account'=>$sc['account'],
                'pwd'=>$this->pwdenc_model->pwd_dencypt($sc['pwd']),
                'center_addr'=>$sc['center_addr'],
                'bak_center_addr' => isset($sc['bakup_center_addr']) ? $sc['bakup_center_addr'] : '',
            );
        }
        return $infor;
    }

    public function get_branchid_by_grp($group_id)
    {
        static $grp_branch_map = null;
        if(is_null($grp_branch_map))
        {
            foreach($this->_recordset as $val)
            {
                $grp_branch_map[$val['group_id']][] = $val['id'];
            }
        }
        return isset($grp_branch_map[$group_id]) ? $grp_branch_map[$group_id] : array();
    }

    //$only_mgmt 只显示集中管理的分支
    public function get_branchinfo_by_grp($group_id, $only_mgmt = false)
    {
        static $grp_branch_map = null;
        if(is_null($grp_branch_map))
        {
            if($only_mgmt)
            {
                $this->get_real_branch_list();
            }
            foreach($this->_recordset as $val)
            {
                if(!$only_mgmt)
                {
                    $grp_branch_map[$val['group_id']][] = $val;
                    continue;
                }
                if(isset($val['mode']) &&
                    ($val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MGMT_MODE ||
                        $val['mode'] === \wns\central_mgmt_mode_e::CENTRAL_MAINTENANCE_MODE ))
                {
                    $grp_branch_map[$val['group_id']][] = $val;
                }
            }
        }
        return isset($grp_branch_map[$group_id]) ? $grp_branch_map[$group_id] : array();
    }

    public function get_branch_path_by_id($id)
    {
        static $branchs_map = null;
        if(is_null($branchs_map))
        {
            foreach ($this->_recordset as $key => $val) {
                $branchs_map[$val['id']] = $val;
            }
            $branchs_map[CENTER_ID] = array(
                'id' => CENTER_ID,
                'name' => __('中心控制器'),
                'group_id' => 1,
            );
        }
        if(is_null($this->central_area_model))
        {
            $this->load->model('sys_configure/central_monitor/central_model');
        }
        if(!isset($branchs_map[$id]))
            return;
        $grppath = $this->central_area_model->get_path_by_grpid($branchs_map[$id]['group_id'], false);
        if($grppath !== '/')
            $grppath = $grppath. '/'. $branchs_map[$id]['name'];
        else
            $grppath = '/'. $branchs_map[$id]['name'];
        return $grppath;
    }

    /**
     * 获取父节点和子节点的map
     * @param null $id
     * @return bool|null
     */
    public function get_parent_child_map($id=null)
    {
        static $relation = null;
        if($relation === null)
        {
            $relation[CENTER_ID] = CENTER_ALL_GROUP_ID;
            foreach($this->_recordset as $key => $val)
            {
                $relation[$val['id']] = $val['group_id'];
            }
        }
        if($id !== null)
            return isset($relation[$id])?$relation[$id]:false;
        return $relation;
    }

    /**修改集中认证托管
     * @param $ids          分支IDS
     * @return bool
     * @throws Exception
     */
    public function modify_center_auth($ids)
    {
        $ids = is_array($ids)?$ids:array($ids);
        if(is_empty($ids))
            return true;
        $binfos = $this->get_branch_list();
        $alldeposit = $this->get_deposit_info();
        $deposit_branch_set = array();
        $ret = true;
        $this->load->model('sys_configure/central_monitor/central_area_model');
        foreach($ids as $id)
        {
            if(isset($binfos[$id])){
                $info = $binfos[$id];
            }else{
                $ret =  false;
                break;
            }
            if(isset($alldeposit['branch'][$id])){/*分支已存在*/
                continue;
            }
            $path = array();
            $this->central_area_model->get_path_ids_by_grpid($path,$info['group_id']);
            $is_deposit = array_intersect($alldeposit['bgrp'],$path);
            if(!empty($is_deposit))/*所在分组已存在*/
                continue;
            $alldeposit['branch'][] = $id;
        }

        if($ret)
        {
            $alldeposit['branch'] = array_unique($alldeposit['branch']);
            $rs = array(
                'deposit_grp_id' => $alldeposit['bgrp'],
                'deposit_account_id' => $alldeposit['branch'],
            );
            $rs = array_to_xml_file('wns.cfg_ap_deposit', $rs, $this->_deposit_conf);
            if (0 !== $rs)
            {
                $str = __('config_unwritable');
                $this->log->add('debug', array($str, $this->_deposit_conf));
                bug($str);
            }

            $this->load->model('php_config_model');
            $this->php_config_model->add($this->_deposit_conf);
            $deposit_branch_set = array_flip($alldeposit['branch']);
            $this->get_all_branchset_by_bgroup_for_deposit($alldeposit['bgrp'],$deposit_branch_set);
            $this->update_config_after_deposit_change($deposit_branch_set);
        }
        return $ret;
    }

    public function delete_branch_from_center_auth($ids)
    {
        $ids = is_array($ids)?$ids:array($ids);
        $rs = array_from_xml_file($this->_deposit_conf , 'wns.cfg_ap_deposit');
        if (is_null($rs) || -1 === $rs)
        {
            bug(__('unexpected_config'));
        }
        $deposit_branch_set = array();
        if(isset($rs['deposit_account_id']))
        {
            foreach($ids as $val)
            {
                $index = array_search($val,$rs['deposit_account_id']);
                if(false !== $index)
                {
                    unset($rs['deposit_account_id'][$index]);
                }
            }
            $deposit_branch_set = array_flip($rs['deposit_account_id']);
        }
        $ret = array_to_xml_file('wns.cfg_ap_deposit', $rs, $this->_deposit_conf);
        if (0 !== $ret)
        {
            $str = __('config_unwritable');
            $this->log->add('debug', array($str, $this->_deposit_conf));
            bug($str);
        }
        $this->load->model('php_config_model');
        $this->php_config_model->add($this->_deposit_conf);
        if(isset($rs['deposit_grp_id']))
        {
            $this->get_all_branchset_by_bgroup_for_deposit($rs['deposit_grp_id'],$deposit_branch_set);
        }
        $this->update_config_after_deposit_change($deposit_branch_set);
    }

    public function get_branch_name_by_id($id)
    {
        static $branchs_name = null;
        if (is_null($branchs_name)) {
            foreach ($this->_recordset as $key => $val) {
                $branchs_name[$val['id']] = $val['name'];
            }
            $branchs_name[0] = __('中心控制器');
        }
        $id = intval($id);
        if(isset($branchs_name[$id]))
        {
            return $branchs_name[$id];
        }
        return null;
    }

    public function get_branch_cnt()
    {
        $branch['online_branch'] = $branch['offline_branch'] = 0;
        $wacrole = $this->get_wac_role();
        if($wacrole === 'center')
        {
            $this->load->model('sys_configure/central_monitor/central_area_model');
            $branchr = $this->central_area_model->get_all_right_branch();
            $replyobj = new \webui_msg\branch_basic_info_resp();
            $bincodec = new \DrSlump\Protobuf\Codec\Binary();
            $ret = php_wns_ipc_to_self(\wns\module_id_e::REALINFO_SRV, 0,
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_REQ, "",
                \wns\webui_msgid_monitor_info_e::BRANCH_WAC_BASIC_STAT_INFO_RESP, 3);
            $branchonline = [];
            if(isset($ret['buf']))
            {
                $obj = $bincodec->decode($replyobj, $ret['buf']);
                $result = $obj->getBranchBasicInfo();
                if(!empty($result))
                {
                    foreach ($result as $key => $val) {
                        if($val->getMonitorStat()) //在线
                        {
                            $branchonline[$val->getAccountId()] = true;
                            $branch['online_branch']++;
                        }
                    }
                }
            }
            foreach($this->_recordset as $key => $val) {
                if(isset($branchr) && is_array($branchr) && !isset($branchr[$val['id']]))
                {
                    $this->_recordset_total--;
                    if(isset($branchonline[$val['id']]))
                    {
                        $branch['online_branch']--;
                    }
                }
            }
            $branch['offline_branch'] = $this->_recordset_total - $branch['online_branch'];
        }
        return $branch;
    }
}
